#ifndef __bitmap_bi__
#define __bitmap_bi__

#include once "common.bi"

enum wxBitmapType
  wxBITMAP_TYPE_INVALID = 0
  wxBITMAP_TYPE_BMP
  wxBITMAP_TYPE_BMP_RESOURCE
  wxBITMAP_TYPE_RESOURCE = wxBITMAP_TYPE_BMP_RESOURCE
  wxBITMAP_TYPE_ICO
  wxBITMAP_TYPE_ICO_RESOURCE
  wxBITMAP_TYPE_CUR
  wxBITMAP_TYPE_CUR_RESOURCE
  wxBITMAP_TYPE_XBM
  wxBITMAP_TYPE_XBM_DATA
  wxBITMAP_TYPE_XPM
  wxBITMAP_TYPE_XPM_DATA
  wxBITMAP_TYPE_TIF
  wxBITMAP_TYPE_TIF_RESOURCE
  wxBITMAP_TYPE_GIF
  wxBITMAP_TYPE_GIF_RESOURCE
  wxBITMAP_TYPE_PNG
  wxBITMAP_TYPE_PNG_RESOURCE
  wxBITMAP_TYPE_JPEG
  wxBITMAP_TYPE_JPEG_RESOURCE
  wxBITMAP_TYPE_PNM
  wxBITMAP_TYPE_PNM_RESOURCE
  wxBITMAP_TYPE_PCX
  wxBITMAP_TYPE_PCX_RESOURCE
  wxBITMAP_TYPE_PICT
  wxBITMAP_TYPE_PICT_RESOURCE
  wxBITMAP_TYPE_ICON
  wxBITMAP_TYPE_ICON_RESOURCE
  wxBITMAP_TYPE_ANI
  wxBITMAP_TYPE_IFF
  wxBITMAP_TYPE_MACCURSOR
  wxBITMAP_TYPE_MACCURSOR_RESOURCE
  wxBITMAP_TYPE_ANY = 50
end enum


_DS(wxBitmap_AddHandler)(handler as _wxBitmapHandler ptr)

_DS(wxBitmap_CleanUpHandlers)

' class wxBitmap
_DF(wxBitmap_NullBitmap) as _wxBitmap ptr

_DF(wxBitmap_ctor)       as _wxBitmap ptr

_DF(wxBitmap_ctorByImage)    (image as _wxImage ptr, depth as wxInt=-1) as _wxBitmap ptr

_DF(wxBitmap_ctorByName)     (nam as _wxString ptr, typ as wxInt) as _wxBitmap ptr

_DF(wxBitmap_ctorBySize)     (w as wxInt, h as wxInt, depth as wxInt) as _wxBitmap ptr

_DF(wxBitmap_ctorByBitmap)   (bitmap as _wxBitmap ptr) as _wxBitmap ptr

_DF(wxBitmap_ctorFromXpmData)(xpm as zstring ptr) as _wxBitmap ptr

_DF(wxBitmap_ctorFromBits)   (pBits as any ptr, w as wxInt, h as wxInt) as _wxBitmap ptr

_DF(wxBitmap_ConvertToImage)(self as _wxBitmap ptr) as _wxImage ptr

_DF(wxBitmap_GetHeight)     (self as _wxBitmap ptr) as wxInt

_DS(wxBitmap_SetHeight)     (self as _wxBitmap ptr, height as wxInt)

_DF(wxBitmap_GetWidth)      (self as _wxBitmap ptr) as wxInt

_DS(wxBitmap_SetWidth)      (self as _wxBitmap ptr, width as wxInt)

_DF(wxBitmap_LoadFile)      (self as _wxBitmap ptr, filename as _wxString ptr, typ as wxBitmapType) as wxBool

_DF(wxBitmap_SaveFile)      (self as _wxBitmap ptr, filename as _wxString ptr, typ as wxBitmapType, pal as _wxPalette ptr) as wxBool

_DF(wxBitmap_Ok)            (self as _wxBitmap ptr) as wxBool

_DF(wxBitmap_GetDepth)      (self as _wxBitmap ptr) as wxInt

_DS(wxBitmap_SetDepth)      (self as _wxBitmap ptr, depth as wxInt)

_DF(wxBitmap_GetSubBitmap)  (self as _wxBitmap ptr, r as _wxRect ptr) as _wxBitmap ptr

_DF(wxBitmap_GetMask)       (self as _wxBitmap ptr) as _wxMask ptr

_DS(wxBitmap_SetMask)       (self as _wxBitmap ptr, mask as _wxMask ptr)

_DF(wxBitmap_GetPalette)    (self as _wxBitmap ptr) as _wxPalette ptr

_DF(wxBitmap_GetColourMap)  (self as _wxBitmap ptr) as _wxPalette ptr

_DF(wxBitmap_CopyFromIcon)  (self as _wxBitmap ptr,icon as _wxIcon ptr) as wxBool

' class wxMask
_DF(wxMask_ctor) as _wxMask ptr

_DF(wxMask_ctorByBitmapColour)(bitmap as _wxBitmap ptr, col as _wxColour ptr) as _wxMask ptr

_DF(wxMask_ctorByBitmapIndex) (bitmap as _wxBitmap ptr, paletteIndex as wxInt) as _wxMask ptr

_DF(wxMask_ctorByBitmap)      (bitmap as _wxBitmap ptr) as _wxMask ptr

_DF(wxMask_CreateByBitmapColour)(self as _wxMask ptr, bitmap as _wxBitmap ptr, col as _wxColour ptr) as wxBool

_DF(wxMask_CreateByBitmapIndex) (self as _wxMask ptr, bitmap as _wxBitmap ptr, paletteIndex as wxInt) as wxBool

_DF(wxMask_CreateByBitmap)      (self as _wxMask ptr, bitmap as _wxBitmap ptr) as wxBool

#endif ' __bitmap_bi__
