#ifndef __button_object_bi__
#define __button_object_bi__

#include once "button.bi"
#include once "evthandler.bi"
#include once "event.bi"

type wxButton
  declare constructor
  declare operator cast as _wxButton ptr
  declare operator cast as _wxWindow ptr
  declare operator cast as _wxEvtHandler ptr
  declare function Create(parent    as _wxWindow ptr=WX_NULL, _
                          id        as  wxInt=-1, _
                          labelArg  as  String="Label", _
                          x         as  wxInt=-1, _
                          y         as  wxInt=-1, _
                          w         as  wxInt=-1, _
                          h         as  wxInt=-1, _
                          style     as  wxInt= 0, _
                          validator as _wxValidator ptr=WX_NULL, _
                          nameArg   as String="wxButton") as wxBool
  declare sub      SetDefault
  declare sub      GetDefaultSize(byref w as wxInt,byref h as wxInt)
  declare sub      SetImageLabel(bitmap as _wxBitmap ptr)
  declare sub      SetImageMargins(x as wxCoord, y as wxCoord)
  declare sub      Label(txt as String)
  declare sub      ClickHandler(veh as Virtual_EventHandler)
  private:
  as _wxButton ptr self
end type

constructor wxButton
  dprint("wxButton()")
end constructor

operator wxButton.cast as _wxButton ptr
  dprint("wxButton->_wxButton")
  return self
end operator
operator wxButton.cast as _wxWindow ptr
  dprint("wxButton->wxWindow")
  return cptr(_wxWindow ptr,self)
end operator
operator wxButton.cast as _wxEvtHandler ptr
  dprint("wxButton->wxEvtHandler")
  return cptr(_wxEvtHandler ptr,self)
end operator

function wxButton.Create(parent    as _wxWindow ptr, _
                         id        as  wxInt, _
                         labelArg  as String, _
                         x         as  wxInt, _
                         y         as  wxInt, _
                         w         as  wxInt, _
                         h         as  wxInt, _
                         style     as  wxInt, _
                         validator as _wxValidator ptr, _
                         nameArg   as String) as wxBool
  
  if (self=WX_NULL) then 
    dprint("wxButton_ctor()")
    self = wxButton_ctor()
  end if
  dprint("wxButton.Create()")
  return wxButton_create(self,parent,id,wxString(labelArg),x,y,w,h,style,validator,wxString(nameArg))
end function

sub wxButton.Label(txt as String)
  if (self=WX_NULL) then return
  dprint("wxButton.Caption()")
  wxButton_SetLabel(self,wxString(txt))
end sub

sub wxButton.GetDefaultSize(byref w as wxInt,byref h as wxInt)
  dprint("wxButton.GetDefaultSize")
  dim as wxSize s
  wxButton_GetDefaultSize(s)
  w=s.w:h=s.h
end sub

sub wxButton.ClickHandler(veh as Virtual_EventHandler)
  if (self=WX_NULL) then return
  dprint("wxButton.ClickHandler()")
  wxEvtHandler_ConnectByType(this,wxEvent_EVT_COMMAND_BUTTON_CLICKED(),veh)
end sub

#endif ' __button_object_bi__
