#ifndef __bytebuffer_object_bi__
#define __bytebuffer_object_bi__

#include once "bytebuffer.bi"

type ByteBuffer
  declare constructor(size as size_t)
  declare operator cast as wxChar ptr
  declare operator cast as wxInt  ptr
  declare operator cast as wxUInt ptr
  declare function Count as size_t
  declare function filled as size_t
  declare property Item(index as size_t,value as wxChar) 
  declare property Item(index as size_t) as wxChar
  private:
  as _ByteBuffer ptr self
end type

constructor ByteBuffer(size as size_t)
  self=ByteBuffer_ctor(size)
end constructor

function Bytebuffer.Count as size_t
  return ByteBuffer_reserved(self)
end function

function Bytebuffer.Filled as size_t
  return ByteBuffer_filled(self)
end function

property ByteBuffer.Item(index as size_t,value as wxChar) 
  ByteBuffer_atSet(self,index,value)
end property
property ByteBuffer.Item(index as size_t) as wxChar 
  return ByteBuffer_at(self,index)
end property

operator ByteBuffer.Cast as wxChar ptr
  return ByteBuffer_ptrToBuffer(self)
end operator
operator ByteBuffer.Cast as wxInt ptr
  return cptr(wxInt ptr,ByteBuffer_ptrToBuffer(self))
end operator
operator ByteBuffer.Cast as wxUInt ptr
  return cptr(wxUInt ptr,ByteBuffer_ptrToBuffer(self))
end operator

#endif ' __bytebuffer_object_bi__
