#ifndef __common_bi__
#define __common_bi__

#include once "crt/stddef.bi"

#ifdef DEBUG
#define DPRINT(msg) open err for output as #99:print #99,msg:close #99 :
#else
#define DPRINT(msg) :
#endif

#ifdef __FB_WIN32__
#libpath "./lib/win32"
#define APICALL STDCALL
#else
#libpath "./lib/linux"
#define APICALL CDECL
#endif

#inclib "wx-c"

#define _DF(n) declare function n APICALL alias #n
#define _DS(n) declare sub      n APICALL alias #n

' in an oop environment we need a safe class type
'( "class as any" isn't safe)
#ifdef WX_OBJECT
# define WXCLASS(n) type n : as any ptr pThis : end type
#else
'#print warning: wxWidgets classes defined as ANY !
# define WXCLASS(n) type n as any
#endif

' filesystem >4GB
#define wxHAS_HUGE_FILES

' none wxWidget classes
WXCLASS(_ByteBuffer)
WXCLASS(_DisposableHtmlTagBox)
WXCLASS(_DisposableStringBox)

' NET classes
WXCLASS(_DotNetFileSystemHandler)

' wxWidgets classes
WXCLASS(_wxAcceleratorArrayNet)
WXCLASS(_wxAcceleratorEntry)
WXCLASS(_wxAcceleratorTable)
WXCLASS(_wxANIHandler)
WXCLASS(_wxApp)
WXCLASS(_wxArchiveEntry)
WXCLASS(_wxArchiveInputStream)
WXCLASS(_wxArchiveInputStreamPair)
WXCLASS(_wxArchiveOutputStreamPair)
WXCLASS(_wxArrayInt)
WXCLASS(_wxArrayIntPtr)
WXCLASS(_wxArrayString)
WXCLASS(_wxArrayTreeItemIds)
WXCLASS(_wxBitmap)
WXCLASS(_wxBitmapButton)
WXCLASS(_wxBitmapDataObject)
WXCLASS(_wxBitmapHandler)
WXCLASS(_wxBMPHandler)
WXCLASS(_wxBoxSizer)
WXCLASS(_wxBrush)
WXCLASS(_wxBrushList)
WXCLASS(_wxBufferedDC)
WXCLASS(_wxBufferedPaintDC)
WXCLASS(_wxBusyInfo)
WXCLASS(_wxButton)
WXCLASS(_wxCalculateLayoutEvent)
WXCLASS(_wxCalendarCtrl)
WXCLASS(_wxCalendarDateAttr)
WXCLASS(_wxCalendarEvent)
WXCLASS(_wxCaret)
WXCLASS(_wxCaretSuspend)
WXCLASS(_wxCheckBox)
WXCLASS(_wxCheckListBox)
WXCLASS(_wxChildFocusEvent)
WXCLASS(_wxChoice)
WXCLASS(_wxClassInfo)
WXCLASS(_wxClientDC)
WXCLASS(_wxClientData)
WXCLASS(_wxClipboard)
WXCLASS(_wxClipboardLocker)
WXCLASS(_wxCloseEvent)
WXCLASS(_wxColour)
WXCLASS(_wxColourData)
WXCLASS(_wxColourDataBase)
WXCLASS(_wxColourDialog)
WXCLASS(_wxColourPickerCtrl)
WXCLASS(_wxColourPickerEvent)
WXCLASS(_wxComboBox)
WXCLASS(_wxComboCtrl)
WXCLASS(_wxComboPopup)
WXCLASS(_wxCommandEvent)
WXCLASS(_wxCommandProcessor)
WXCLASS(_wxConfigBase)
WXCLASS(_wxContextMenuEvent)
WXCLASS(_wxControl)
WXCLASS(_wxControlWithItems)
WXCLASS(_wxCURHandler)
WXCLASS(_wxCursor)
WXCLASS(_wxDateEvent)
WXCLASS(_wxDatePickerCtrl)
WXCLASS(_wxDataFormat)
WXCLASS(_wxDataObject)
WXCLASS(_wxDataObjectComposite)
WXCLASS(_wxDataObjectSimple)
WXCLASS(_wxDateTime)
WXCLASS(_wxDC)
WXCLASS(_wxDialog)
WXCLASS(_wxDirDialog)
WXCLASS(_wxDisplayChangedEvent)
WXCLASS(_wxDocument)
WXCLASS(_wxDocManager)
WXCLASS(_wxDocTemplate)
WXCLASS(_wxDropSource)
WXCLASS(_wxDropFilesEvent)
WXCLASS(_wxDropTarget)
WXCLASS(_wxEncodingConverter)
WXCLASS(_wxEraseEvent)
WXCLASS(_wxEvtHandler)
WXCLASS(_wxEvent)
WXCLASS(_wxFileDataObject)
WXCLASS(_wxFileDialog)
WXCLASS(_wxFileDropTarget)
WXCLASS(_wxFileSystem)
WXCLASS(_wxFileSystemHandler)
WXCLASS(_wxFindReplaceData)
WXCLASS(_wxFindReplaceDialog)
WXCLASS(_wxFindDialogEvent)
WXCLASS(_wxFlexGridSizer)
WXCLASS(_wxFocusEvent)
WXCLASS(_wxFont)
WXCLASS(_wxFontData)
WXCLASS(_wxFontDialog)
WXCLASS(_wxFontEnumerator)
WXCLASS(_wxFontList)
WXCLASS(_wxFontMapper)
WXCLASS(_wxFontPickerCtrl)
WXCLASS(_wxFontPickerEvent)
WXCLASS(_wxFrame)
WXCLASS(_wxFSFile)
WXCLASS(_wxGauge)
WXCLASS(_wxGBPosition)
WXCLASS(_wxGBSizerItem)
WXCLASS(_wxGBSpan)
WXCLASS(_wxGDIObject)
WXCLASS(_wxGIFHandler)
WXCLASS(_wxGLCanvas)
WXCLASS(_wxGLContext)
WXCLASS(_wxGrid)
WXCLASS(_wxGridBagSizer)
WXCLASS(_wxGridCellAttr)
WXCLASS(_wxGridCellAttrProvider)
WXCLASS(_wxGridCellAutoWrapStringEditor)
WXCLASS(_wxGridCellAutoWrapStringRenderer)
WXCLASS(_wxGridCellBoolEditor)
WXCLASS(_wxGridCellBoolRenderer)
WXCLASS(_wxGridCellCoords)
WXCLASS(_wxGridCellCoordsArray)
WXCLASS(_wxGridCellChoiceEditor)
WXCLASS(_wxGridCellDateTimeRenderer)
WXCLASS(_wxGridCellEditor)
WXCLASS(_wxGridCellEnumRenderer)
WXCLASS(_wxGridCellEnumEditor)
WXCLASS(_wxGridCellFloatEditor)
WXCLASS(_wxGridCellFloatRenderer)
WXCLASS(_wxGridCellNumberEditor)
WXCLASS(_wxGridCellNumberRenderer)
WXCLASS(_wxGridCellRenderer)
WXCLASS(_wxGridCellStringEditor)
WXCLASS(_wxGridCellStringRenderer)
WXCLASS(_wxGridCellTextEditor)
WXCLASS(_wxGridCellWorker)
WXCLASS(_wxGridEditorCreatedEvent)
WXCLASS(_wxGridEvent)
WXCLASS(_wxGridRangeSelectEvent)
WXCLASS(_wxGridSizeEvent)
WXCLASS(_wxGridSizer)
WXCLASS(_wxGridStringTable)
WXCLASS(_wxGridTableBase)
WXCLASS(_wxGridTableMessage)
WXCLASS(_wxHelpEvent)
WXCLASS(_wxHitTest)
WXCLASS(_wxHtmlBookRecArray)
WXCLASS(_wxHtmlBookRecord)
WXCLASS(_wxHtmlCell)
WXCLASS(_wxHtmlColourCell)
WXCLASS(_wxHtmlContainerCell)
WXCLASS(_wxHtmlEasyPrinting)
WXCLASS(_wxHtmlEntitiesParser)
WXCLASS(_wxHtmlFilter)
WXCLASS(_wxHtmlFilterHTML)
WXCLASS(_wxHtmlFilterPlainText)
WXCLASS(_wxHtmlFontCell)
WXCLASS(_wxHtmlHelpController)
WXCLASS(_wxHtmlHelpFrame)
WXCLASS(_wxHtmlHelpData)
WXCLASS(_wxHtmlHelpDataItems)
WXCLASS(_wxHtmlHelpDataItem)
WXCLASS(_wxHtmlLinkInfo)
WXCLASS(_wxHtmlListBox)
WXCLASS(_wxHtmlParser)
WXCLASS(_wxHtmlProcessor)
WXCLASS(_wxHtmlRenderingInfo)
WXCLASS(_wxHtmlSearchStatus)
WXCLASS(_wxHtmlSelection)
WXCLASS(_wxHtmlTag)
WXCLASS(_wxHtmlTagsModule)
WXCLASS(_wxHtmlTagHandler)
WXCLASS(_wxHtmlWidgetCell)
WXCLASS(_wxHtmlWindow)
WXCLASS(_wxHtmlWinParser)
WXCLASS(_wxHtmlWordCell)
WXCLASS(_wxIcon)
WXCLASS(_wxIconBundle)
WXCLASS(_wxICOHandler)
WXCLASS(_wxIconizeEvent)
WXCLASS(_wxIdleEvent)
WXCLASS(_wxImage)
WXCLASS(_wxImageHandler)
WXCLASS(_wxImageHistogram)
WXCLASS(_wxImageHistogramEntry)
WXCLASS(_wxImageList)
WXCLASS(_wxInitDialogEvent)
WXCLASS(_wxInputStream)
WXCLASS(_wxInternetFSHandler)
WXCLASS(_wxJPEGHandler)
WXCLASS(_wxKeyEvent)
WXCLASS(_wxLanguageInfo)
WXCLASS(_wxLayoutAlgorithm)
WXCLASS(_wxLayoutConstraints)
WXCLASS(_wxList)
WXCLASS(_wxListbook)
WXCLASS(_wxListbookEvent)
WXCLASS(_wxListBox)
WXCLASS(_wxListCtrl)
WXCLASS(_wxListEvent)
WXCLASS(_wxListItemAttr)
WXCLASS(_wxListItem)
WXCLASS(_wxListView)
WXCLASS(_wxLocale)
WXCLASS(_wxLog)
WXCLASS(_wxMask)
WXCLASS(_wxMaximizeEvent)
WXCLASS(_wxMDIChildFrame)
WXCLASS(_wxMDIClientWindow)
WXCLASS(_wxMDIParentFrame)
WXCLASS(_wxMemoryBuffer)
WXCLASS(_wxMemoryDC)
WXCLASS(_wxMemoryFSHandler)
WXCLASS(_wxMenu)
WXCLASS(_wxMenuBar)
WXCLASS(_wxMenuBase)
WXCLASS(_wxMenuItem)
WXCLASS(_wxMessageDialog)
WXCLASS(_wxMiniFrame)
WXCLASS(_wxMouseCaptureChangedEvent)
WXCLASS(_wxMouseEvent)
WXCLASS(_wxMoveEvent)
WXCLASS(_wxMultiChoiceDialog)
WXCLASS(_wxNativeFontInfo)
WXCLASS(_wxNavigationKeyEvent)
WXCLASS(_wxNcPaintEvent)
WXCLASS(_wxNode)
WXCLASS(_wxNotebook)
WXCLASS(_wxNotebookBase)
WXCLASS(_wxNotebookEvent)
WXCLASS(_wxNotebookPage)
WXCLASS(_wxNotifyEvent)
WXCLASS(_wxObject)
WXCLASS(_wxOutputStream)
WXCLASS(_wxPageSetupData)
WXCLASS(_wxPageSetupDialog)
WXCLASS(_wxPageSetupDialogData)
WXCLASS(_wxPaintDC)
WXCLASS(_wxPaintEvent)
WXCLASS(_wxPalette)
WXCLASS(_wxPaletteChangedEvent)
WXCLASS(_wxPanel)
WXCLASS(_wxPaperSize)
WXCLASS(_wxPCXHandler)
WXCLASS(_wxPen)
WXCLASS(_wxPenList)
WXCLASS(_wxPickerBase)
WXCLASS(_wxPNGHandler)
WXCLASS(_wxPNMHandler)
WXCLASS(_wxPoint)
WXCLASS(_wxPreviewCanvas)
WXCLASS(_wxPreviewFrame)
WXCLASS(_wxPrintData)
WXCLASS(_wxPrintDialog)
WXCLASS(_wxPrintDialogData)
WXCLASS(_wxPrinter)
WXCLASS(_wxPrintOut)
WXCLASS(_wxPrintPreview)
WXCLASS(_wxPrintPreviewBase)
WXCLASS(_wxPrintSetupData)
WXCLASS(_wxPrintSetupDialog)
WXCLASS(_wxProgressDialog)
WXCLASS(_wxQueryLayoutInfoEvent)
WXCLASS(_wxQueryLayoutEvent)
WXCLASS(_wxQueryNewPaletteEvent)
WXCLASS(_wxRadioBox)
WXCLASS(_wxRadioButton)
WXCLASS(_wxRect)
WXCLASS(_wxRegion)
WXCLASS(_wxRegionIterator)
WXCLASS(_wxSashEdge)
WXCLASS(_wxSashEvent)
WXCLASS(_wxSashLayoutWindow)
WXCLASS(_wxSashWindow)
WXCLASS(_wxScrollBar)
WXCLASS(_wxScrolledWindow)
WXCLASS(_wxSetCursorEvent)
WXCLASS(_wxShowEvent)
WXCLASS(_wxSingleChoiceDialog)
WXCLASS(_wxSize)
WXCLASS(_wxSizeEvent)
WXCLASS(_wxSizer)
WXCLASS(_wxSizerItem)
WXCLASS(_wxSlider)
WXCLASS(_wxSound)
WXCLASS(_wxSpinButton)
WXCLASS(_wxSpinCtrl)
WXCLASS(_wxSpinEvent)
WXCLASS(_wxSplashScreen)
WXCLASS(_wxSplashScreenWindow)
WXCLASS(_wxSplitterWindow)
WXCLASS(_wxStaticBitmap)
WXCLASS(_wxStaticBox)
WXCLASS(_wxStaticBoxSizer)
WXCLASS(_wxStaticLine)
WXCLASS(_wxStaticText)
WXCLASS(_wxStatusBar)
WXCLASS(_wxString)
WXCLASS(_wxStringClientData)
WXCLASS(_wxStyledTextCtrl)
WXCLASS(_wxStyledTextEvent)
WXCLASS(_wxSysColourChangedEvent)
#ifdef __FB_WIN32__
WXCLASS(_wxTabCtrl)
WXCLASS(_wxTabEvent)
#endif
WXCLASS(_wxTaskBarIcon)
WXCLASS(_wxTextAttr)
WXCLASS(_wxTextCtrl)
WXCLASS(_wxTextDataObject)
WXCLASS(_wxTextDropTarget)
WXCLASS(_wxTextEntryDialog)
WXCLASS(_wxTextUrlEvent)
WXCLASS(_wxTIFFHandler)
WXCLASS(_wxTimer)
WXCLASS(_wxTipProvider)
WXCLASS(_wxTipWindow)
WXCLASS(_wxToggleButton)
WXCLASS(_wxToolBar)
WXCLASS(_wxToolBarBase)
WXCLASS(_wxToolBarToolBase)
WXCLASS(_wxToolTip)
WXCLASS(_wxTopLevelWindow)
WXCLASS(_wxTreeCtrl)
WXCLASS(_wxTreeEvent)
WXCLASS(_wxTreeItemAttr)
WXCLASS(_wxTreeItemData)
WXCLASS(_wxTreeItemIcon)
WXCLASS(_wxTreeItemId)
WXCLASS(_wxUpdateUIEvent)
WXCLASS(_wxValidator)
WXCLASS(_wxView)
WXCLASS(_wxVisualAttributes)
WXCLASS(_wxVListBox)
WXCLASS(_wxVScrolledWindow)
WXCLASS(_wxWCharBuffer)
WXCLASS(_wxWindow)
WXCLASS(_wxWindowCreateEvent)
WXCLASS(_wxWindowDC)
WXCLASS(_wxWindowDestroyEvent)
WXCLASS(_wxWindowDisabler)
WXCLASS(_wxWizard)
WXCLASS(_wxWizardEvent)
WXCLASS(_wxWizardPage)
WXCLASS(_wxWizardPageSimple)
WXCLASS(_wxXmlResource)
WXCLASS(_wxXPMHandler)
WXCLASS(_wxZipFSHandler)

#define WX_TRUE 1
#define WX_FALSE 0
#define WX_NULL cptr(any ptr,0)

' wx simple data types
type wxChar      as ubyte
type wxInt       as integer
type wxUInt      as uinteger
type wxFloat     as single
type wxDouble    as double
type wxLong      as long
type wxCoord     as wxInt
type wxBool      as wxChar
type wxWindowID  as wxInt
type wxEventType as wxInt
type wxWeekDay   as wxInt
type wxTextCoord as wxLong

#ifdef wxHAS_HUGE_FILES
type off_t as longint
#else
type off_t as integer
#endif

type wxFileOffset as off_t
type _wxWidget as any 
' callbacks used by many wx classes
type Virtual_Dispose   as sub      APICALL 

#endif ' __common_bi__
