#ifndef __filesys_bi__
#define __filesys_bi__

#include once "common.bi"

type Virtual_InputStream_OnDispose as sub      APICALL
type Virtual_InputStream_CanRead   as function APICALL as wxInt
type Virtual_InputStream_LastRead  as function APICALL as size_t
type Virtual_InputStream_Read      as function APICALL (buffer as _ByteBuffer ptr) as size_t
type Virtual_InputStream_CanRead   as function APICALL as wxInt
type Virtual_InputStream_CanSeek   as function APICALL as wxInt
type Virtual_InputStream_Seek      as function APICALL (p as wxLong, r as wxInt) as wxLong
type Virtual_InputStream_Tell      as function APICALL as wxLong
type Virtual_InputStream_GetLength as function APICALL as wxLong

type Virtual_FileSystemHandler_CanOpen   as function APICALL (f as _wxString ptr) as wxBool
type Virtual_FileSystemHandler_OpenFile  as function APICALL (s as _wxFileSystem ptr, n as _wxString ptr) as _wxFSFile ptr
type Virtual_FileSystemHandler_FindFirst as function APICALL (f as _wxString ptr, i as wxInt) as _wxString ptr
type Virtual_FileSystemHandler_FindNext  as function APICALL as _wxString ptr

_DF(wxInputStreamWrapper_ctor)() as _wxInputStream ptr

' class wxInputStream
_DS(wxInputStreamWrapper_dtor)(self as _wxInputStream ptr)
_DS(wxInputStreamWrapper_RegisterVirtual)(self as _wxInputStream ptr, _
                         on_Dispose as Virtual_InputStream_OnDispose, _
                         fLastRead  as Virtual_InputStream_LastRead , _
                         fSysRead   as Virtual_InputStream_Read     , _
                         fCanRead   as Virtual_InputStream_CanRead  , _
                         fCanSeek   as Virtual_InputStream_CanSeek  , _
                         fSeek      as Virtual_InputStream_Seek     , _
                         fTell      as Virtual_InputStream_Tell     , _
                         fGetLength as Virtual_InputStream_GetLength )

_DS(wxInputStreamWrapper_UnregisterVirtual)(self as _wxInputStream ptr)

_DF(wxInputStreamWrapper_Peek)(self as _wxInputStream ptr) as wxChar

_DF(wxInputStreamWrapper_GetC)(self as _wxInputStream ptr) as wxChar

_DS(wxInputStreamWrapper_ReadIntoBuffer)(self as _wxInputStream ptr, buffer as _ByteBuffer ptr)

_DS(wxInputStreamWrapper_ReadIntoStream)(self as _wxInputStream ptr, os as _wxOutputStream ptr)

_DF(wxInputStreamWrapper_LastRead)(self as _wxInputStream ptr) as size_t

_DF(wxInputStreamWrapper_CanRead)(self as _wxInputStream ptr) as wxBool

_DF(wxInputStreamWrapper_Eof)(self as _wxInputStream ptr) as wxBool

_DF(wxInputStreamWrapper_UngetBuffer)(self as _wxInputStream ptr, pBuffer as any ptr, size as size_t) as size_t 

_DF(wxInputStreamWrapper_Ungetch)(self as _wxInputStream ptr, c as wxChar) as wxChar

_DF(wxInputStreamWrapper_SeekI)(self as _wxInputStream ptr, p as wxFileOffset, mode as wxSeekMode) as wxFileOffset

_DF(wxInputStreamWrapper_TellI)(self as _wxInputStream ptr) as wxFileOffset

' class wxFSFile
_DF(wxFSFile_ctor)(InputStraem      as _wxInputStream ptr, _
                   Location         as _wxString ptr, _
                   MimeType         as _wxString ptr, _
                   Anchor           as _wxString ptr, _
                   ModificationTime as _wxDateTime ptr) as _wxFSFile ptr

_DS(wxFSFile_SetDisposeCallback)(self as _wxFSFile ptr, on_dispose as Virtual_Dispose)

_DS(wxFSFile_UnsetDisposeCallback)(self as _wxFSFile ptr)

_DS(wxFSFile_dtor)(self as _wxFSFile ptr)

_DF(wxFSFile_GetAnchor)(self as _wxFSFile ptr) as _wxString ptr

_DF(wxFSFile_GetLocation)(self as _wxFSFile ptr) as _wxString ptr

_DF(wxFSFile_GetMimeType)(self as _wxFSFile ptr) as _wxString ptr

_DF(wxFSFile_GetModificationTime)(self as _wxFSFile ptr) as _wxDateTime ptr

_DF(wxFSFile_GetStream)(self as _wxFSFile ptr) as _wxInputStream ptr

' class wxFileSystemHandler
_DF(wxFileSystemHandler_CanOpen)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as wxBool

_DF(wxFileSystemHandler_FindFirst)(self as _wxFileSystemHandler ptr, wildcard as _wxString ptr, kindOfFile as wxInt) as _wxString ptr

_DF(wxFileSystemHandler_FindNext)(self as _wxFileSystemHandler ptr) as _wxString ptr

_DF(wxFileSystemHandler_GetAnchor)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as _wxString ptr

_DF(wxFileSystemHandler_GetProtocol)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as _wxString ptr

_DF(wxFileSystemHandler_GetLeftLocation)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as _wxString ptr

_DF(wxFileSystemHandler_GetRightLocation)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as _wxString ptr

_DF(wxFileSystemHandler_GetMimeTypeFromExt)(self as _wxFileSystemHandler ptr, location as _wxString ptr) as _wxString ptr

' class wxFileSystem
_DF(wxFileSystem_ctor)() as _wxFileSystem ptr

_DS(wxFileSystem_AddHandler)(fsh as _wxFileSystemHandler ptr)

_DS(wxFileSystem_CleanUpHandlers)()

_DS(wxFileSystem_ChangePathTo)(self as _wxFileSystem ptr, location as _wxString ptr, is_dir as wxBool)

_DF(wxFileSystem_GetPath)(self as _wxFileSystem ptr) as _wxString ptr

_DF(wxFileSystem_FindFirst)(self as _wxFileSystem ptr, wildcard as _wxString ptr, kindOfFile as wxInt) as _wxString ptr

_DF(wxFileSystem_FindNext)(self as _wxFileSystem ptr) as _wxString ptr

_DF(wxFileSystem_OpenFile)(self as _wxFileSystem ptr, location as _wxString ptr) as _wxFSFile ptr


' class wxZipFSHandler
_DF(wxZipFSHandler_ctor) as _wxZipFSHandler ptr

_DF(wxZipFSHandler_OpenFile)(self as _wxZipFSHandler ptr, fs as _wxFileSystem ptr, location as _wxString ptr) as _wxFSFile ptr


' class wxInternetFSHandler
_DF(wxInternetFSHandler_ctor) as _wxInternetFSHandler ptr

_DF(wxInternetFSHandler_OpenFile)(self as _wxInternetFSHandler ptr, fs as _wxFileSystem ptr, location as _wxString ptr) as _wxFSFile ptr


' class wxMemoryFSHandler
_DF(wxMemoryFSHandler_ctor) as _wxMemoryFSHandler ptr

_DF(wxMemoryFSHandler_OpenFile)(self as _wxMemoryFSHandler ptr, fs as _wxFileSystem ptr, location as _wxString ptr) as _wxFSFile ptr

_DS(wxMemoryFSHandler_AddImage)(filename as _wxString ptr, img as _wxImage ptr, typ as wxInt)

_DS(wxMemoryFSHandler_AddBitmap)(filename as _wxString ptr, bitmap as _wxBitmap ptr, typ as wxInt)

_DS(wxMemoryFSHandler_AddText)(filename as _wxString ptr, txt as _wxString ptr)

_DS(wxMemoryFSHandler_AddBinaryData)(filename as _wxString ptr, pData as any ptr, size as size_t)

_DS(wxMemoryFSHandler_RemoveFile)(filename as _wxString ptr)


' class wxDotNetFileSystemHandler
_DF(dotNetFileSystemHandler_ctor) as _DotNetFileSystemHandler ptr

_DS(dotNetFileSystemHandler_RegisterVirtual)(self as _DotNetFileSystemHandler ptr, _
                                             on_dispose as Virtual_Dispose, _
                                             fCanOpen   as Virtual_FileSystemHandler_CanOpen  , _
                                             fOpenFile  as Virtual_FileSystemHandler_OpenFile , _
                                             fFindFirst as Virtual_FileSystemHandler_FindFirst, _
                                             fFindNext  as Virtual_FileSystemHandler_FindNext)

_DS(dotNetFileSystemHandler_UnregisterVirtual)(self as _DotNetFileSystemHandler ptr)

#endif ' __filesys_bi__
