#ifndef __frame_object_bi__
#define __frame_object_bi__

#include once "frame.bi"
#include once "window.bi"

' class wxFrame
type wxFrame
  declare constructor
  declare function Create (parent   as _wxWindow ptr, _
                           id       as  wxWindowID, _
                           titleArg as String, _
                           x        as wxInt, _
                           y        as wxInt, _
                           w        as wxInt, _
                           h        as wxInt, _
                           style    as wxUInt=wxFRAME_DEFAULT_STYLE, _
                           nameArg  as String="wxFrame") as wxBool
                           
  declare function Create (id       as wxWindowID=-1, _
                           titleArg as String="", _
                           x        as wxInt=-1, _
                           y        as wxInt=-1, _
                           w        as wxInt=-1, _
                           h        as wxInt=-1, _
                           style    as wxUInt=wxFRAME_DEFAULT_STYLE, _
                           nameArg  as String="wxFrame") as wxBool
                           
  declare function Create (titleArg as String="", _
                           x        as wxInt=-1, _
                           y        as wxInt=-1, _
                           w        as wxInt=-1, _
                           h        as wxInt=-1, _
                           style    as wxUInt=wxFRAME_DEFAULT_STYLE, _
                           nameArg  as String="wxFrame") as wxBool

  declare operator cast as _wxWindow ptr
  
  declare function ShowFullScreen (bshow as wxBool, style as wxFullScreen) as wxBool
  declare function IsFullScreen as wxBool

  declare property Maximize(bMaximize as wxBool)
  declare property Maximize as wxBool

  declare property Iconize(bIconize as wxBool)
  declare property Iconize as wxBool

  declare property Icon(icon_ as _wxIcon ptr)
  declare property Icon as _wxIcon ptr

  declare property MenuBar(menubar_ as _wxMenuBar ptr)
  declare property MenuBar as _wxMenuBar ptr

  declare sub GetClientAreaOrigin(p as _wxPoint ptr)
  declare sub SendSizeEvent

  ' class wxStatusBar
  declare function CreateStatusBar(number  as wxInt    , _
                                   style   as wxUInt= 0, _
                                   id      as wxInt =-1, _
                                   nameArg as String="wxStatusBar") as _wxStatusBar ptr
  
  declare property StatusBar(stbar as _wxStatusBar ptr)
  declare property StatusBar as _wxStatusBar ptr

  declare property StatusBarPane(n as wxInt)
  declare property StatusBarPane as wxInt

  declare sub      SetStatusWidths(n as wxInt, widths as wxInt ptr)
  declare sub      SetStatusText(txt as String, n as wxInt)
  
  ' class wxToolBar
  declare function CreateToolBar(style as wxUInt, id as wxInt, nameArg as String="wxToolBar") as _wxToolBar ptr
  
  declare property ToolBar(toolbar as _wxToolBar ptr)
  declare property ToolBar as _wxToolBar ptr


  private:
  as _wxFrame ptr self
end type

constructor wxFrame
  dprint("wxFrame()")
end constructor

function wxFrame.Create(parent   as _wxWindow ptr, _
                        id       as  wxWindowID, _
                        titleArg as  String, _
                        x        as  wxInt, _
                        y        as  wxInt, _
                        w        as  wxInt, _
                        h        as  wxInt, _
                        style    as  wxUInt, _
                        nameArg  as  String) as wxBool
  if (self=WX_NULL) then
    dprint("wxFrame_ctor()")
    self=wxFrame_ctor()
  end if
  dprint("wxFrame.Create()")
  return wxFrame_create(self,parent,id,wxString(titleArg),x,y,w,h,style,wxString(nameArg))
end function

function wxFrame.Create(id as wxWindowID, _
                        titleArg as String, _
                        x        as wxInt, _
                        y        as wxInt, _
                        w        as wxInt, _
                        h        as wxInt, _
                        style    as wxUInt, _
                        nameArg  as String) as wxBool
  return Create(0,id,titleArg,x,y,w,h,style,nameArg)
end function
function wxFrame.Create(titleArg as String, _
                        x        as wxInt, _
                        y        as wxInt, _
                        w        as wxInt, _
                        h        as wxInt, _
                        style    as wxUInt,_
                        nameArg  as String) as wxBool
  return Create(0,-1,titleArg, x,y,w,h, style,nameArg)
end function

operator wxFrame.cast as _wxWindow ptr
  dprint("wxFrame->wxWindow")
  return cptr(_wxWindow ptr,self)
end operator

function wxFrame.ShowFullScreen (bShow as wxBool, style as wxFullScreen) as wxBool
  return wxFrame_ShowFullScreen(self,bshow,style)
end function
function wxFrame.IsFullScreen as wxBool
  return wxFrame_IsFullScreen(self)
end function

property wxFrame.Maximize(bMaximize as wxBool)
  wxFrame_Maximize(self,bMaximize)
end property
property wxFrame.Maximize as wxBool
  return wxFrame_IsMaximized(self)
end property

property wxFrame.Iconize(bIconize as wxBool)
  wxFrame_Iconize self,bIconize
end property
property wxFrame.Iconize as wxBool
  return wxFrame_IsIconized(self)
end property

property wxFrame.Icon(icon_ as _wxIcon ptr)
  wxFrame_SetIcon(self,icon_)
end property
property wxFrame.Icon as _wxIcon ptr
  return wxFrame_GetIcon(self)
end property

property wxFrame.MenuBar(menubar_ as _wxMenuBar ptr)
  wxFrame_SetMenuBar(self,menubar)
end property
property wxFrame.MenuBar as _wxMenuBar ptr
  return wxFrame_GetMenuBar(self)
end property

sub wxFrame.GetClientAreaOrigin(p as _wxPoint ptr)
  wxFrame_GetClientAreaOrigin(self, p)
end sub

sub wxFrame.SendSizeEvent
  wxFrame_SendSizeEvent(self)
end sub

function wxFrame.CreateStatusBar(number as wxInt, style as wxUInt, id as wxInt, nameArg as String) as _wxStatusBar ptr
  
  if nameArg<>"" then
    dprint("CreateStatusBar nameArg")
    return wxFrame_CreateStatusBar(self,number,style,id,wxString(nameArg))
  else
    dprint("CreateStatusBar")
    return wxFrame_CreateStatusBar(self,number,style,id)
  end if
end function

property wxFrame.StatusBar(stbar as _wxStatusBar ptr)
  wxFrame_SetStatusBar(self,stbar)
end property
property wxFrame.StatusBar as _wxStatusBar ptr
  return wxFrame_GetStatusBar(self)
end property

property wxFrame.StatusBarPane(n as wxInt)
  wxFrame_SetStatusBarPane(self,n)
end property
property wxFrame.StatusBarPane as wxInt
  return wxFrame_GetStatusBarPane(self)
end property

sub wxFrame.SetStatusWidths(n as wxInt, widths as wxInt ptr)
  wxFrame_SetStatusWidths(self,n,widths)
end sub
sub wxFrame.SetStatusText(txt as String, n as wxInt)
  wxFrame_SetStatusText(self,wxString(txt),n)
end sub

#endif ' __frame_object_bi__
