#ifndef __grid_bi__
#define __grid_bi__

#include once "common.bi"

type Virtual_SetParameters       as sub      APICALL (p as _wxString ptr)

type Virtual_Create              as sub      APICALL (ein as _wxWindow ptr, id as wxWindowID, wvnt as _wxEvtHandler ptr)
type Virtual_BeginEdit           as sub      APICALL (x as wxInt, y as wxInt, grid as _wxGrid ptr)
type Virtual_EndEdit             as function APICALL (x as wxInt, y as wxInt, grid as _wxGrid ptr) as wxBool
type Virtual_Reset               as sub      APICALL
type Virtual_Clone               as function APICALL as _wxGridCellEditor ptr
type Virtual_SetSize             as sub      APICALL (r as _wxRect ptr)
type Virtual_Show                as sub      APICALL (i as wxInt, gca as _wxGridCellAttr ptr)
type Virtual_PaintBackground     as sub      APICALL (r as _wxRect ptr, gca as _wxGridCellAttr ptr)
type Virtual_IsAcceptedKey       as function APICALL (k as _wxKeyEvent ptr) as wxBool
type Virtual_StartingKey         as sub      APICALL (k as _wxKeyEvent ptr)
type Virtual_StartingClick       as sub      APICALL
type Virtual_HandleReturn        as sub      APICALL (k as _wxKeyEvent ptr)
type Virtual_Destroy             as sub      APICALL
type Virtual_GetValue            as function APICALL as _DisposableStringBox ptr

type Virtual_GetNumberRows       as function APICALL () as wxInt
type Virtual_GetNumberCols       as function APICALL () as wxInt
type Virtual_IsEmptyCell         as function APICALL (as wxInt, as wxInt) as wxBool
type Virtual_GetValue2           as function APICALL ( as wxInt, as wxInt) as _DisposableStringBox ptr
type Virtual_SetValue            as sub      APICALL ( as wxInt, as wxInt, value as _wxString ptr)
type Virtual_CanGetValueAs       as function APICALL ( as wxInt, as wxInt, as _wxString ptr) as wxBool
type Virtual_GetValueAsLong      as function APICALL ( as wxInt, as wxInt) as wxLong
type Virtual_GetValueAsDouble    as function APICALL ( as wxInt, as wxInt) as wxDouble
type Virtual_SetValueAsLong      as sub      APICALL ( as wxInt, as wxInt, as wxLong)
type Virtual_SetValueAsDouble    as sub      APICALL ( as wxInt, as wxInt, as wxDouble)
type Virtual_SetValueAsBool      as sub      APICALL ( as wxInt, as wxInt, as wxBool)
type Virtual_GetValueAsCustom    as function APICALL ( as wxInt, as wxInt, as _wxString ptr) as any ptr
type Virtual_SetValueAsCustom    as sub      APICALL ( as wxInt, as wxInt, as _wxString ptr, as any ptr)
type Virtual_GetColLabelValue    as function APICALL ( as wxInt) as _DisposableStringBox ptr
type Virtual_SetView             as sub      APICALL (as _wxGrid ptr)
type Virtual_GetView             as function APICALL as _wxGrid ptr
type Virtual_Clear               as sub      APICALL 
type Virtual_InsertRows          as function APICALL (as wxInt, as wxInt) as wxBool
type Virtual_AppendRows          as function APICALL (as wxInt) as wxBool
type Virtual_SetRowLabelValue    as sub      APICALL (as wxInt, as _wxString ptr)
type Virtual_SetAttrProvider     as sub      APICALL (as _wxGridCellAttrProvider ptr)
type Virtual_GetAttrProvider     as function APICALL as _wxGridCellAttrProvider ptr
type Virtual_CanHaveAttributes   as function APICALL  as wxBool
type Virtual_GetAttr             as function APICALL (as wxInt, as wxInt,kind as wxAttrKind) as _wxGridCellAttr ptr
type Virtual_SetAttr             as sub      APICALL (gca as _wxGridCellAttr ptr, as wxInt, as wxInt)
type Virtual_SetRowAttr          as sub      APICALL (gca as _wxGridCellAttr ptr, as wxInt)

type Virtual_Draw                as sub      APICALL (grid as _wxGrid ptr, as _wxGridCellAttr ptr, as _wxDC ptr, r as _wxRect ptr, x as wxInt, y as wxInt, as wxBool)
type Virtual_GetBestSize         as function APICALL (grid as _wxGrid ptr, gca as _wxGridCellAttr ptr, dc as _wxDC ptr, x as wxInt, y as wxInt) as _wxSize ptr
type Virtual_RendererClone       as function APICALL as _wxGridCellRenderer ptr


' class wxGridEvent
_DF(wxGridEvent_ctor)(id    as wxInt, _
                      typ   as wxEventType, _
                      obj   as _wxObject ptr, _
                      row   as wxInt, _
                      col   as wxInt, _
                      x     as wxInt, _
                      y     as wxInt, _
                      sel   as wxBool, _
                      ctl   as wxBool, _
                      shift as wxBool, _
                      alt   as wxBool, _
                      meta  as wxBool) as _wxGridEvent ptr

_DF(wxGridEvent_GetRow)(self as _wxGridEvent ptr) as wxInt

_DF(wxGridEvent_GetCol)(self as _wxGridEvent ptr) as wxInt

_DS(wxGridEvent_GetPosition)(self as _wxGridEvent ptr, pt as _wxPoint ptr)

_DF(wxGridEvent_Selecting)(self as _wxGridEvent ptr) as wxBool

_DF(wxGridEvent_ControlDown)(self as _wxGridEvent ptr) as wxBool

_DF(wxGridEvent_MetaDown)(self as _wxGridEvent ptr) as wxBool

_DF(wxGridEvent_ShiftDown)(self as _wxGridEvent ptr) as wxBool

_DF(wxGridEvent_AltDown)(self as _wxGridEvent ptr) as wxBool

_DS(wxGridEvent_Veto)(self as _wxGridEvent ptr)

_DS(wxGridEvent_Allow)(self as _wxGridEvent ptr)

_DF(wxGridEvent_IsAllowed)(self as _wxGridEvent ptr) as wxBool

' class wxGridRangeSelectEvent
_DF(wxGridRangeSelectEvent_ctor)(id          as wxInt, _
                                 typ         as wxEventType, _
                                 obj         as _wxObject ptr, _
                                 topleft     as _wxGridCellCoords ptr, _
                                 bottomRight as _wxGridCellCoords ptr, _
                                 sel         as wxBool, _
                                 control     as wxBool, _
                                 shift       as wxBool, _
                                 alt         as wxBool, _
                                 meta        as wxBool) as _wxGridRangeSelectEvent ptr

_DF(wxGridRangeSelectEvent_GetTopLeftCoords)(self as _wxGridRangeSelectEvent ptr) as _wxGridCellCoords ptr

_DF(wxGridRangeSelectEvent_GetBottomRightCoords)(self as _wxGridRangeSelectEvent ptr) as _wxGridCellCoords ptr

_DF(wxGridRangeSelectEvent_GetTopRow)(self as _wxGridRangeSelectEvent ptr) as wxInt

_DF(wxGridRangeSelectEvent_GetBottomRow)(self as _wxGridRangeSelectEvent ptr) as wxInt

_DF(wxGridRangeSelectEvent_GetLeftCol)(self as _wxGridRangeSelectEvent ptr) as wxInt

_DF(wxGridRangeSelectEvent_GetRightCol)(self as _wxGridRangeSelectEvent ptr) as wxInt

_DF(wxGridRangeSelectEvent_Selecting)(self as _wxGridRangeSelectEvent ptr) as wxBool

_DF(wxGridRangeSelectEvent_ControlDown)(self as _wxGridRangeSelectEvent ptr) as wxBool

_DF(wxGridRangeSelectEvent_MetaDown)(self as _wxGridRangeSelectEvent ptr) as wxBool

_DF(wxGridRangeSelectEvent_ShiftDown)(self as _wxGridRangeSelectEvent ptr) as wxBool

_DF(wxGridRangeSelectEvent_AltDown)(self as _wxGridRangeSelectEvent ptr) as wxBool

_DS(wxGridRangeSelectEvent_Veto)(self as _wxGridRangeSelectEvent ptr)

_DS(wxGridRangeSelectEvent_Allow)(self as _wxGridRangeSelectEvent ptr)

_DF(wxGridRangeSelectEvent_IsAllowed)(self as _wxGridRangeSelectEvent ptr) as wxBool


' class wxGridCellWorker
_DF(wxGridCellWorker_ctor) as _wxGridCellWorker ptr

_DS(wxGridCellWorker_RegisterVirtual)(self as _wxGridCellWorker ptr, fSetParams as Virtual_SetParameters)

_DS(wxGridCellWorker_IncRef)(self as _wxGridCellWorker ptr)

_DS(wxGridCellWorker_DecRef)(self as _wxGridCellWorker ptr)

_DS(wxGridCellWorker_SetParameters)(self as _wxGridCellWorker ptr, params as _wxString ptr)


' class wxGridEditorCreatedEvent
_DF(wxGridEditorCreatedEvent_ctor)(id as wxInt, _
                                   typ as wxEventType, _
                                   obj as _wxObject ptr, _
                                   row as wxInt, _
                                   col as wxInt, _
                                   control as _wxControl ptr) as _wxGridEditorCreatedEvent ptr

_DF(wxGridEditorCreatedEvent_GetRow)(self as _wxGridEditorCreatedEvent ptr) as wxInt

_DF(wxGridEditorCreatedEvent_GetCol)(self as _wxGridEditorCreatedEvent ptr) as wxInt

_DF(wxGridEditorCreatedEvent_GetControl)(self as _wxGridEditorCreatedEvent ptr) as _wxControl ptr

_DS(wxGridEditorCreatedEvent_SetRow)(self as _wxGridEditorCreatedEvent ptr, row as wxInt)

_DS(wxGridEditorCreatedEvent_SetCol)(self as _wxGridEditorCreatedEvent ptr, col as wxInt)

_DS(wxGridEditorCreatedEvent_SetControl)(self as _wxGridEditorCreatedEvent ptr, ctrl as _wxControl ptr)


' class wxGrid
_DF(wxGrid_ctor) as _wxGrid ptr

_DF(wxGrid_ctorFull)(parent  as _wxWindow ptr     , _
                     id      as  wxWindowID   = -1, _
                     x       as  wxInt        = -1, _
                     y       as  wxInt        = -1, _
                     w       as  wxInt        = -1, _
                     h       as  wxInt        = -1, _
                     style   as  wxInt        =  0, _
                     nameArg as _wxString ptr = WX_NULL) as _wxGrid ptr

_DS(wxGrid_dtor)(self as _wxGrid ptr)   

_DF(wxGrid_CreateGrid)(self as _wxGrid ptr, numRows as wxInt, numCols as wxInt, mode as wxGridSelectionModes) as wxBool

_DS(wxGrid_SetSelectionMode)(self as _wxGrid ptr, mode as wxGridSelectionModes)

_DF(wxGrid_GetSelectionMode)(self as _wxGrid ptr) as wxGridSelectionModes

_DF(wxGrid_GetNumberRows)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetNumberCols)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_ProcessRowLabelMouseEvent)(self as _wxGrid ptr, evn as _wxMouseEvent ptr)

_DS(wxGrid_ProcessColLabelMouseEvent)(self as _wxGrid ptr, evn as _wxMouseEvent ptr)

_DS(wxGrid_ProcessCornerLabelMouseEvent)(self as _wxGrid ptr, evn as _wxMouseEvent ptr)

_DS(wxGrid_ProcessGridCellMouseEvent)(self as _wxGrid ptr, evn as _wxMouseEvent ptr)

_DF( wxGrid_ProcessTableMessage)(self as _wxGrid ptr, msg as _wxGridTableMessage ptr) as wxBool

_DF(wxGridTableMessage_ctor1) as _wxGridTableMessage ptr

_DF(wxGridTableMessage_ctor2)(table as _wxGridTableBase ptr, id as wxInt, comInt1 as wxInt, comInt2 as wxInt) as _wxGridTableMessage ptr

_DS( wxGridTableMessage_SetTableObject)(self as _wxGridTableMessage ptr, table as _wxGridTableBase ptr)

_DF(wxGridTableMessage_GetTableObject)(self as _wxGridTableMessage ptr) as _wxGridTableBase ptr

_DS(wxGridTableMessage_SetId)(self as _wxGridTableMessage ptr, id as wxInt)

_DF(wxGridTableMessage_GetId)(self as _wxGridTableMessage ptr) as wxInt

_DS(wxGridTableMessage_SetCommandInt)(self as _wxGridTableMessage ptr, ComInt as wxInt)

_DF(wxGridTableMessage_GetCommandInt)(self as _wxGridTableMessage ptr) as wxInt

_DS(wxGridTableMessage_SetCommandInt2)(self as _wxGridTableMessage ptr, ComInt as wxInt)

_DF(wxGridTableMessage_GetCommandInt2)(self as _wxGridTableMessage ptr) as wxInt

_DF(wxGrid_GetTable)(self as _wxGrid ptr) as _wxGridTableBase ptr

_DF(wxGrid_SetTable)(self as _wxGrid ptr, table as _wxGridTableBase ptr, takeOwnership as wxBool, mode as wxGridSelectionModes) as wxBool

_DF(wxGridStringTable_GetNumberRows)(self as _wxGridStringTable ptr) as wxInt

_DF(wxGridStringTable_GetNumberCols)(self as _wxGridStringTable ptr) as wxInt

_DF(wxGridStringTable_IsEmptyCell)(self as _wxGridStringTable ptr, row as wxInt, col as wxInt) as wxBool

_DF(wxGridStringTable_GetValue)(self as _wxGridStringTable ptr, row as wxInt, col as wxInt) as _wxString ptr

_DS(wxGridStringTable_SetValue)(self as _wxGridStringTable ptr, row as wxInt, col as wxInt, value as _wxString ptr)

_DS(wxGrid_ClearGrid)(self as _wxGrid ptr)

_DF(wxGrid_InsertRows)(self as _wxGrid ptr,position as wxInt, numRows as wxInt, updateLabels as wxBool) as wxBool

_DF(wxGrid_AppendRows)(self as _wxGrid ptr, numRows as wxInt, updateLabels as wxBool) as wxBool

_DF(wxGrid_DeleteRows)(self as _wxGrid ptr,position as wxInt, numRows as wxInt, updateLabels as wxBool) as wxBool

_DF(wxGrid_InsertCols)(self as _wxGrid ptr,position as wxInt,  numCols as wxInt, updateLabels as wxBool) as wxBool

_DF(wxGrid_AppendCols)(self as _wxGrid ptr,  numCols as wxInt, updateLabels as wxBool) as wxBool

_DF(wxGrid_DeleteCols)(self as _wxGrid ptr,position as wxInt,  numCols as wxInt, updateLabels as wxBool) as wxBool

_DS(wxGrid_DrawGridCellArea)(self as _wxGrid ptr, dc as _wxDC ptr, cells as _wxGridCellCoordsArray ptr)

_DS(wxGrid_DrawGridSpace)(self as _wxGrid ptr, dc as _wxDC ptr)

_DS(wxGrid_BeginBatch)(self as _wxGrid ptr)

_DS(wxGrid_EndBatch)(self as _wxGrid ptr)

_DF(wxGrid_GetBatchCount)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_ForceRefresh)(self as _wxGrid ptr)

_DF(wxGrid_IsEditable)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_EnableEditing)(self as _wxGrid ptr, edit as wxBool)

_DS(wxGrid_EnableCellEditControl)(self as _wxGrid ptr, enable as wxBool)

_DS(wxGrid_DisableCellEditControl)(self as _wxGrid ptr)

_DF(wxGrid_CanEnableCellControl)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_IsCellEditControlEnabled)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_IsCellEditControlShown)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_IsCurrentCellReadOnly)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_ShowCellEditControl)(self as _wxGrid ptr)

_DS(wxGrid_HideCellEditControl)(self as _wxGrid ptr)

_DS(wxGrid_SaveEditControlValue)(self as _wxGrid ptr)

_DF(wxGrid_YToRow)(self as _wxGrid ptr, y as wxInt) as wxInt

_DF(wxGrid_XToCol)(self as _wxGrid ptr, y as wxInt) as wxInt

_DF(wxGrid_YToEdgeOfRow)(self as _wxGrid ptr, y as wxInt) as wxInt

_DF(wxGrid_XToEdgeOfCol)(self as _wxGrid ptr, y as wxInt) as wxInt

_DS(wxGrid_CellToRect)(self as _wxGrid ptr, row as wxInt, col as wxInt, r as _wxRect ptr)

_DF(wxGrid_GetGridCursorRow)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetGridCursorCol)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_IsVisible)(self as _wxGrid ptr, row as wxInt, col as wxInt, wholeCellVisible as wxBool) as wxBool

_DS(wxGrid_MakeCellVisible)(self as _wxGrid ptr, row as wxInt, col as wxInt)

_DS(wxGrid_SetGridCursor)(self as _wxGrid ptr, row as wxInt, col as wxInt)

_DF(wxGrid_MoveCursorUp)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorDown)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorLeft)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorRight)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MovePageDown)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_MovePageUp)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_MoveCursorUpBlock)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorDownBlock)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorLeftBlock)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_MoveCursorRightBlock)(self as _wxGrid ptr, expandSelection as wxBool) as wxBool

_DF(wxGrid_GetDefaultRowLabelSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetRowLabelSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetDefaultColLabelSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetColLabelSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetLabelBackgroundColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetLabelTextColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetLabelFont)(self as _wxGrid ptr) as _wxFont ptr

_DS(wxGrid_GetRowLabelAlignment)(self as _wxGrid ptr, h as wxInt ptr, v as wxInt ptr)

_DS(wxGrid_GetColLabelAlignment)(self as _wxGrid ptr, h as wxInt ptr, v as wxInt ptr)

_DF(wxGrid_GetRowLabelValue)(self as _wxGrid ptr, row as wxInt) as _wxString ptr

_DF(wxGrid_GetColLabelValue)(self as _wxGrid ptr, col as wxInt) as _wxString ptr

_DF(wxGrid_GetGridLineColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetCellHighlightColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetCellHighlightPenWidth)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetCellHighlightROPenWidth)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_SetRowLabelSize)(self as _wxGrid ptr, w as wxInt)

_DS(wxGrid_SetColLabelSize)(self as _wxGrid ptr, h as wxInt)

_DS(wxGrid_SetLabelBackgroundColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetLabelTextColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetLabelFont)(self as _wxGrid ptr, font as _wxFont ptr)

_DS(wxGrid_SetRowLabelAlignment)(self as _wxGrid ptr, h as wxInt, v as wxInt)

_DS(wxGrid_SetColLabelAlignment)(self as _wxGrid ptr, h as wxInt, v as wxInt)

_DS(wxGrid_SetRowLabelValue)(self as _wxGrid ptr, row as wxInt, value as _wxString ptr)

_DS(wxGrid_SetColLabelValue)(self as _wxGrid ptr, col as wxInt, value as _wxString ptr)

_DS(wxGrid_SetGridLineColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetCellHighlightColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetCellHighlightPenWidth)(self as _wxGrid ptr, w as wxInt)

_DS(wxGrid_SetCellHighlightROPenWidth)(self as _wxGrid ptr, w as wxInt)

_DS(wxGrid_EnableDragRowSize)(self as _wxGrid ptr, enable as wxBool)

_DS(wxGrid_DisableDragRowSize)(self as _wxGrid ptr)

_DF(wxGrid_CanDragRowSize)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_EnableDragColSize)(self as _wxGrid ptr, enable as wxBool)

_DS(wxGrid_DisableDragColSize)(self as _wxGrid ptr)

_DF(wxGrid_CanDragColSize)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_EnableDragGridSize)(self as _wxGrid ptr, enable as wxBool)

_DS(wxGrid_DisableDragGridSize)(self as _wxGrid ptr)

_DF(wxGrid_CanDragGridSize)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_SetAttr)(self as _wxGrid ptr, row as wxInt, col as wxInt, attr as _wxGridCellAttr ptr)

_DS(wxGrid_SetRowAttr)(self as _wxGrid ptr, row as wxInt, attr as _wxGridCellAttr ptr)

_DS(wxGrid_SetColAttr)(self as _wxGrid ptr, col as wxInt, attr as _wxGridCellAttr ptr)

_DS(wxGrid_SetColFormatBool)(self as _wxGrid ptr, col as wxInt)

_DS(wxGrid_SetColFormatNumber)(self as _wxGrid ptr, col as wxInt)

_DS(wxGrid_SetColFormatFloat)(self as _wxGrid ptr, col as wxInt, w as wxInt, precision as wxInt)

_DS(wxGrid_SetColFormatCustom)(self as _wxGrid ptr, col as wxInt, typeName as _wxString ptr)

_DS(wxGrid_EnableGridLines)(self as _wxGrid ptr, enable as wxBool)

_DF(wxGrid_GridLinesEnabled)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_GetDefaultRowSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetRowSize)(self as _wxGrid ptr, row as wxInt) as wxInt

_DF(wxGrid_GetDefaultColSize)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetColSize)(self as _wxGrid ptr, col as wxInt) as wxInt

_DF(wxGrid_GetDefaultCellBackgroundColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetCellBackgroundColour)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxColour ptr

_DF(wxGrid_GetDefaultCellTextColour)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetCellTextColour)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxColour ptr

_DF(wxGrid_GetDefaultCellFont)(self as _wxGrid ptr) as _wxFont ptr

_DF(wxGrid_GetCellFont)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxFont ptr

_DS(wxGrid_GetDefaultCellAlignment)(self as _wxGrid ptr, h as wxInt ptr, v as wxInt ptr)

_DS(wxGrid_GetCellAlignment)(self as _wxGrid ptr, row as wxInt, col as wxInt, h as wxInt ptr, v as wxInt ptr)

_DF(wxGrid_GetDefaultCellOverflow)(self as _wxGrid ptr) as wxBool

_DF(wxGrid_GetCellOverflow)(self as _wxGrid ptr, row as wxInt, col as wxInt) as wxBool

_DS(wxGrid_GetCellSize)(self as _wxGrid ptr, row as wxInt, col as wxInt, nRows as wxInt ptr, nCols as wxInt ptr)

_DS(wxGrid_SetDefaultRowSize)(self as _wxGrid ptr, h as wxInt, resizeExistingRows as wxBool)

_DS(wxGrid_SetRowSize)(self as _wxGrid ptr, row as wxInt, h as wxInt)

_DS(wxGrid_SetDefaultColSize)(self as _wxGrid ptr, w as wxInt, resizeExistingCols as wxBool)

_DS(wxGrid_SetColSize)(self as _wxGrid ptr, col as wxInt, w as wxInt)

_DS(wxGrid_AutoSizeColumn)(self as _wxGrid ptr, col as wxInt, setAsMin as wxBool)

_DS(wxGrid_AutoSizeRow)(self as _wxGrid ptr, row as wxInt, setAsMin as wxBool)

_DS(wxGrid_AutoSizeColumns)(self as _wxGrid ptr, setAsMin as wxBool)

_DS(wxGrid_AutoSizeRows)(self as _wxGrid ptr, setAsMin as wxBool)

_DS(wxGrid_AutoSize)(self as _wxGrid ptr)

_DS(wxGrid_SetColMinimalWidth)(self as _wxGrid ptr, col as wxInt, w as wxInt)

_DS(wxGrid_SetRowMinimalHeight)(self as _wxGrid ptr, row as wxInt, w as wxInt)

_DS(wxGrid_SetColMinimalAcceptableWidth)(self as _wxGrid ptr, w as wxInt)

_DS(wxGrid_SetRowMinimalAcceptableHeight)(self as _wxGrid ptr, w as wxInt)

_DF(wxGrid_GetColMinimalAcceptableWidth)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetRowMinimalAcceptableHeight)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_SetDefaultCellBackgroundColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetDefaultCellTextColour)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetDefaultCellFont)(self as _wxGrid ptr, font as _wxFont ptr)

_DS(wxGrid_SetCellFont)(self as _wxGrid ptr, row as wxInt, col as wxInt, font as _wxFont ptr)

_DS(wxGrid_SetDefaultCellAlignment)(self as _wxGrid ptr, h as wxInt, v as wxInt)

_DS(wxGrid_SetCellAlignmentHV)(self as _wxGrid ptr, row as wxInt, col as wxInt, h as wxInt, v as wxInt)

_DS(wxGrid_SetDefaultCellOverflow)(self as _wxGrid ptr, allow as wxBool)

_DS(wxGrid_SetCellOverflow)(self as _wxGrid ptr, row as wxInt, col as wxInt, allow as wxBool)

_DS(wxGrid_SetCellSize)(self as _wxGrid ptr, row as wxInt, col as wxInt, nRows as wxInt, nCols as wxInt)

_DS(wxGrid_SetDefaultRenderer)(self as _wxGrid ptr, renderer as _wxGridCellRenderer ptr)

_DS(wxGrid_SetCellRenderer)(self as _wxGrid ptr, row as wxInt, col as wxInt, renderer as _wxGridCellRenderer ptr)

_DF(wxGrid_GetDefaultRenderer)(self as _wxGrid ptr) as _wxGridCellRenderer ptr

_DF(wxGrid_GetCellRenderer)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxGridCellRenderer ptr

_DS(wxGrid_SetDefaultEditor)(self as _wxGrid ptr, editor as _wxGridCellEditor ptr)

_DS(wxGrid_SetCellEditor)(self as _wxGrid ptr, row as wxInt, col as wxInt, editor as _wxGridCellEditor ptr)

_DF(wxGrid_GetDefaultEditor)(self as _wxGrid ptr) as _wxGridCellEditor ptr

_DF(wxGrid_GetCellEditor)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxGridCellEditor ptr

_DF(wxGrid_GetCellValue)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxString ptr

_DS(wxGrid_SetCellValue)(self as _wxGrid ptr, row as wxInt, col as wxInt, Value as _wxString ptr)

_DF(wxGrid_IsReadOnly)(self as _wxGrid ptr, row as wxInt, col as wxInt) as wxBool

_DS(wxGrid_SetReadOnly)(self as _wxGrid ptr, row as wxInt, col as wxInt, IsReadOnly as wxBool)

_DS(wxGrid_SelectRow)(self as _wxGrid ptr, row as wxInt, addToEnd as wxBool)

_DS(wxGrid_SelectCol)(self as _wxGrid ptr, col as wxInt, addToEnd as wxBool)

_DS(wxGrid_SelectBlock)(self as _wxGrid ptr, topRow as wxInt, leftCol as wxInt, bottomRow as wxInt, rightCol as wxInt, addToSelected as wxBool)

_DS(wxGrid_SelectAll)(self as _wxGrid ptr)

_DF(wxGrid_IsSelection)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_DeselectRow)(self as _wxGrid ptr, row as wxInt)

_DS(wxGrid_DeselectCol)(self as _wxGrid ptr, col as wxInt)

_DS(wxGrid_DeselectCell)(self as _wxGrid ptr, row as wxInt, col as wxInt)

_DS(wxGrid_ClearSelection)(self as _wxGrid ptr)

_DF(wxGrid_IsInSelection)(self as _wxGrid ptr, row as wxInt, col as wxInt) as wxBool

_DF(wxGrid_GetSelectedCells)(self as _wxGrid ptr) as _wxGridCellCoordsArray ptr

_DF(wxGrid_GetSelectionBlockTopLeft)(self as _wxGrid ptr) as _wxGridCellCoordsArray ptr

_DF(wxGrid_GetSelectionBlockBottomRight)(self as _wxGrid ptr) as _wxGridCellCoordsArray ptr

_DF(wxGrid_GetSelectedRows)(self as _wxGrid ptr) as _wxArrayInt ptr

_DF(wxGrid_GetSelectedCols)(self as _wxGrid ptr) as _wxArrayInt ptr

_DS(wxGrid_BlockToDeviceRect)(self as _wxGrid ptr, topLeft as _wxGridCellCoords ptr, bottomRight as _wxGridCellCoords ptr, r as _wxRect ptr)

_DF(wxGrid_GetSelectionBackground)(self as _wxGrid ptr) as _wxColour ptr

_DF(wxGrid_GetSelectionForeground)(self as _wxGrid ptr) as _wxColour ptr

_DS(wxGrid_SetSelectionBackground)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetSelectionForeground)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_RegisterDataType)(self as _wxGrid ptr, typeName as _wxString ptr, renderer as _wxGridCellRenderer ptr, editor as _wxGridCellEditor ptr)

_DF(wxGrid_GetDefaultEditorForCell)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxGridCellEditor ptr

_DF(wxGrid_GetDefaultRendererForCell)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxGridCellRenderer ptr

_DF(wxGrid_GetDefaultEditorForType)(self as _wxGrid ptr, typeName as _wxString ptr) as _wxGridCellEditor ptr

_DF(wxGrid_GetDefaultRendererForType)(self as _wxGrid ptr, typeName as _wxString ptr) as _wxGridCellRenderer ptr

_DS(wxGrid_SetMargins)(self as _wxGrid ptr, w as wxInt, h as wxInt)

_DF(wxGrid_GetGridWindow)(self as _wxGrid ptr) as _wxWindow ptr

_DF(wxGrid_GetGridRowLabelWindow)(self as _wxGrid ptr) as _wxWindow ptr

_DF(wxGrid_GetGridColLabelWindow)(self as _wxGrid ptr) as _wxWindow ptr

_DF(wxGrid_GetGridCornerLabelWindow)(self as _wxGrid ptr) as _wxWindow ptr

_DS(wxGrid_UpdateDimensions)(self as _wxGrid ptr)

_DF(wxGrid_GetRows)(self as _wxGrid ptr) as wxInt 

_DF(wxGrid_GetCols)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetCursorRow)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetCursorColumn)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetScrollPosX)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetScrollPosY)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_SetScrollX)(self as _wxGrid ptr, y as wxInt)

_DS(wxGrid_SetScrollY)(self as _wxGrid ptr, y as wxInt)

_DS(wxGrid_SetColumnWidth)(self as _wxGrid ptr, col as wxInt, w as wxInt)

_DF(wxGrid_GetColumnWidth)(self as _wxGrid ptr, col as wxInt) as wxInt

_DS(wxGrid_SetRowHeight)(self as _wxGrid ptr, row as wxInt, h as wxInt)

_DF(wxGrid_GetViewHeight)(self as _wxGrid ptr) as wxInt

_DF(wxGrid_GetViewWidth)(self as _wxGrid ptr) as wxInt

_DS(wxGrid_SetLabelSize)(self as _wxGrid ptr, orientation as wxInt, sz as wxInt)

_DF(wxGrid_GetLabelSize)(self as _wxGrid ptr, orientation as wxInt) as wxInt

_DS(wxGrid_SetLabelAlignment)(self as _wxGrid ptr, orientation as wxInt, align as wxInt)

_DF(wxGrid_GetLabelAlignment)(self as _wxGrid ptr, orientation as wxInt, align as wxInt) as wxInt

_DS(wxGrid_SetLabelValue)(self as _wxGrid ptr, orientation as wxInt, value as _wxString ptr,position as wxInt)

_DF(wxGrid_GetLabelValue)(self as _wxGrid ptr, orientation as wxInt,position as wxInt) as _wxString ptr

_DF(wxGrid_GetCellTextFontGrid)(self as _wxGrid ptr) as _wxFont ptr

_DF(wxGrid_GetCellTextFont)(self as _wxGrid ptr, row as wxInt, col as wxInt) as _wxFont ptr

_DS(wxGrid_SetCellTextFontGrid)(self as _wxGrid ptr, font as _wxFont ptr)

_DS(wxGrid_SetCellTextFont)(self as _wxGrid ptr, font as _wxFont ptr, row as wxInt, col as wxInt)

_DS(wxGrid_SetCellTextColour)(self as _wxGrid ptr, row as wxInt, col as wxInt, c as _wxColour ptr)

_DS(wxGrid_SetCellTextColourGrid)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetCellBackgroundColourGrid)(self as _wxGrid ptr, col as _wxColour ptr)

_DS(wxGrid_SetCellBackgroundColour)(self as _wxGrid ptr, row as wxInt, col as wxInt, col as _wxColour ptr)

_DF(wxGrid_GetEditable)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_SetEditable)(self as _wxGrid ptr, edit as wxBool)

_DF(wxGrid_GetEditInPlace)(self as _wxGrid ptr) as wxBool

_DS(wxGrid_SetCellAlignment)(self as _wxGrid ptr, align as wxInt, row as wxInt, col as wxInt)

_DS(wxGrid_SetCellAlignmentGrid)(self as _wxGrid ptr, align as wxInt)

_DS(wxGrid_SetCellBitmap)(self as _wxGrid ptr, bitmap as _wxBitmap ptr, row as wxInt, col as wxInt)

_DS(wxGrid_SetDividerPen)(self as _wxGrid ptr, pen as _wxPen ptr)

_DF(wxGrid_GetDividerPen)(self as _wxGrid ptr) as _wxPen ptr

_DS(wxGrid_OnActivate)(self as _wxGrid ptr, active as wxBool)

_DF(wxGrid_GetRowHeight)(self as _wxGrid ptr, row as wxInt) as wxInt

' class wxGridCellCoords
_DF(wxGridCellCoords_ctor) as _wxGridCellCoords ptr

_DS(wxGridCellCoords_dtor)(self as _wxGridCellCoords ptr)

_DF(wxGridCellCoords_GetRow)(self as _wxGridCellCoords ptr) as wxInt

_DS(wxGridCellCoords_SetRow)(self as _wxGridCellCoords ptr, n as wxInt)

_DF(wxGridCellCoords_GetCol)(self as _wxGridCellCoords ptr) as wxInt

_DS(wxGridCellCoords_SetCol)(self as _wxGridCellCoords ptr, n as wxInt)

_DS(wxGridCellCoords_Set)(self as _wxGridCellCoords ptr, row as wxInt, col as wxInt)

_DS(wxGridCellCoordsArray_dtor)(sel as _wxGridCellCoordsArray ptr)

_DF(wxGridCellCoordsArray_Item)(sel as _wxGridCellCoordsArray ptr, n as wxInt) as _wxGridCellCoords ptr

_DF(wxGridCellCoordsArray_GetCount)(sel as _wxGridCellCoordsArray ptr) as wxInt


' class wxGridCellAttr
_DF(wxGridCellAttr_ctor)(TextCol as _wxColour ptr, colBack as _wxColour ptr, font as _wxFont ptr, h as wxInt, v as wxInt) as _wxGridCellAttr ptr

_DF(wxGridCellAttr_ctor2) as _wxGridCellAttr ptr

_DF(wxGridCellAttr_ctor3)(DefaultAttr as _wxGridCellAttr ptr) as _wxGridCellAttr ptr

_DS(wxGridCellAttr_RegisterDispose)(sel as _wxGridCellAttr ptr, on_dispose as Virtual_Dispose)

_DF(wxGridCellAttr_Clone)(self as _wxGridCellAttr ptr) as _wxGridCellAttr ptr

_DS(wxGridCellAttr_MergeWith)(sel as _wxGridCellAttr ptr, mergefrom as _wxGridCellAttr ptr)

_DS(wxGridCellAttr_IncRef)(sel as _wxGridCellAttr ptr)

_DS(wxGridCellAttr_DecRef)(sel as _wxGridCellAttr ptr)

_DS(wxGridCellAttr_SetTextColour)(sel as _wxGridCellAttr ptr, col as _wxColour ptr)

_DS(wxGridCellAttr_SetBackgroundColour)(sel as _wxGridCellAttr ptr, col as _wxColour ptr)

_DS(wxGridCellAttr_SetFont)(sel as _wxGridCellAttr ptr, font as _wxFont ptr)

_DS(wxGridCellAttr_SetAlignment)(sel as _wxGridCellAttr ptr, h as wxInt, v as wxInt)

_DS(wxGridCellAttr_SetSize)(sel as _wxGridCellAttr ptr, nRows as wxInt, nCols as wxInt)

_DS(wxGridCellAttr_SetOverflow)(sel as _wxGridCellAttr ptr, allow as wxBool)

_DS(wxGridCellAttr_SetReadOnly)(sel as _wxGridCellAttr ptr, IsReadOnly as wxBool)

_DS(wxGridCellAttr_SetRenderer)(sel as _wxGridCellAttr ptr, renderer as _wxGridCellRenderer ptr)

_DS(wxGridCellAttr_SetEditor)(sel as _wxGridCellAttr ptr, editor as _wxGridCellEditor ptr)

_DF(wxGridCellAttr_HasTextColour)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasBackgroundColour)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasFont)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasAlignment)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasRenderer)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasEditor)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_HasReadWriteMode)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_GetTextColour)(sel as _wxGridCellAttr ptr) as _wxColour ptr

_DF(wxGridCellAttr_GetBackgroundColour)(sel as _wxGridCellAttr ptr) as _wxColour ptr

_DF(wxGridCellAttr_GetFont)(sel as _wxGridCellAttr ptr) as _wxFont ptr

_DS(wxGridCellAttr_GetAlignment)(sel as _wxGridCellAttr ptr, h as wxInt ptr, v as wxInt ptr)

_DS(wxGridCellAttr_GetSize)(sel as _wxGridCellAttr ptr, nRows as wxInt ptr, nCols as wxInt ptr)

_DF(wxGridCellAttr_GetOverflow)(sel as _wxGridCellAttr ptr) as wxBool

_DF(wxGridCellAttr_GetRenderer)(sel as _wxGridCellAttr ptr, grid as _wxGrid ptr, row as wxInt, col as wxInt) as _wxGridCellRenderer ptr

_DF(wxGridCellAttr_GetEditor)(sel as _wxGridCellAttr ptr, grid as _wxGrid Ptr, row as wxInt, col as wxInt) as _wxGridCellEditor ptr

_DF(wxGridCellAttr_IsReadOnly)(sel as _wxGridCellAttr ptr) as wxBool 

_DS(wxGridCellAttr_SetDefAttr)(sel as _wxGridCellAttr ptr, attr as _wxGridCellAttr ptr)


' class wxGridSizeEvent
_DF(wxGridSizeEvent_ctor) as _wxGridSizeEvent ptr

_DF(wxGridSizeEvent_ctorParam)(id       as  wxInt, _
                               typ      as  wxEventType, _
                               obj      as _wxObject ptr, _
                               RowOrCol as  wxInt, _
                               x        as  wxInt, _
                               y        as  wxInt, _
                               control  as  wxBool, _
                               shift    as  wxBool, _
                               alt      as  wxBool, _
                               meta     as  wxBool) as _wxGridSizeEvent ptr

_DF(wxGridSizeEvent_GetRowOrCol)(self as _wxGridSizeEvent ptr) as wxInt

_DS(wxGridSizeEvent_GetPosition)(self as _wxGridSizeEvent ptr, pt as _wxPoint ptr)

_DF(wxGridSizeEvent_ControlDown)(self as _wxGridSizeEvent ptr) as wxBool

_DF(wxGridSizeEvent_MetaDown)(self as _wxGridSizeEvent ptr) as wxBool

_DF(wxGridSizeEvent_ShiftDown)(self as _wxGridSizeEvent ptr) as wxBool

_DF(wxGridSizeEvent_AltDown)(self as _wxGridSizeEvent ptr) as wxBool

_DS(wxGridSizeEvent_Veto)(self as _wxGridSizeEvent ptr)

_DS(wxGridSizeEvent_Allow)(self as _wxGridSizeEvent ptr)

_DF(wxGridSizeEvent_IsAllowed)(self as _wxGridSizeEvent ptr) as wxBool


' class wxGridCellEditor
_DF(wxGridCellEditor_ctor) as _wxGridCellEditor ptr

_DS(wxGridCellEditor_RegisterVirtual)(self        as _wxGridCellEditor ptr, _
                                      on_dispose  as Virtual_Dispose, _
                                      fCreate     as Virtual_Create, _
                                      fBeginEdit  as Virtual_BeginEdit, _
                                      fEndEdit    as Virtual_EndEdit, _
                                      fReset      as Virtual_Reset, _
                                      fClone      as Virtual_Clone, _
                                      fSetSize    as Virtual_SetSize, _
                                      fShow       as Virtual_Show, _
                                      fPaintBgr   as Virtual_PaintBackground , _
                                      fIsAccKey   as Virtual_IsAcceptedKey , _
                                      fStartKey   as Virtual_StartingKey, _
                                      fStartClick as Virtual_StartingClick, _
                                      fHandleRet  as Virtual_HandleReturn, _
                                      fDestroy    as Virtual_Destroy, _
                                      fGetValue   as Virtual_GetValue)



_DS(wxGridCellEditor_DeregisterVirtual)(self as _wxGridCellEditor ptr)

_DS(wxGridCellEditor_dtor)(self as _wxGridCellEditor ptr)

_DS(wxGridCellEditor_Create)(self as _wxGridCellEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DF(wxGridCellEditor_IsCreated)(self as _wxGridCellEditor ptr) as wxBool

_DS(wxGridCellEditor_SetControl)(self as _wxGridCellEditor ptr, control as _wxControl ptr)

_DF(wxGridCellEditor_GetControl)(self as _wxGridCellEditor ptr) as _wxControl ptr

_DF(wxGridCellEditor_IsAcceptedKey)(self as _wxGridCellEditor ptr, evnt as _wxKeyEvent ptr) as wxBool

_DS(wxGridCellEditor_SetSize)(self as _wxGridCellEditor ptr, x as wxInt, y as wxInt, w as wxInt, h as wxInt)

_DS(wxGridCellEditor_Show)(self as _wxGridCellEditor ptr, show as wxBool, attr as _wxGridCellAttr ptr)

_DS(wxGridCellEditor_PaintBackground)(self as _wxGridCellEditor ptr, r as _wxRect ptr, attr as _wxGridCellAttr ptr)

_DS(wxGridCellEditor_StartingKey)(self as _wxGridCellEditor ptr, evnt as _wxKeyEvent ptr)

_DS(wxGridCellEditor_StartingClick)(self as _wxGridCellEditor ptr)

_DS(wxGridCellEditor_HandleReturn)(self as _wxGridCellEditor ptr, evnt as _wxKeyEvent ptr)

_DS(wxGridCellEditor_Destroy)(self as _wxGridCellEditor ptr)


' class wxGridTableBase...
_DF(wxGridTableBase_ctor) as _wxGridTableBase ptr


_DS(wxGridTableBase_RegisterVirtual)(self as _wxGridTableBase ptr, _
                                     fGetNumberRows     as Virtual_GetNumberRows, _
                                     fGetNumberCols     as Virtual_GetNumberCols, _
                                     fIsEmptyCell       as Virtual_IsEmptyCell, _
                                     fGetValue          as Virtual_GetValue2, _
                                     fSetValue          as Virtual_SetValue, _
                                     fGetTypeName       as Virtual_GetValue2, _
                                     fCanGetValueAs     as Virtual_CanGetValueAs, _
                                     fCanSetValueAs     as Virtual_CanGetValueAs, _
                                     fGetValueAsLong    as Virtual_GetValueAsLong, _
                                     fGetValueAsDouble  as Virtual_GetValueAsDouble, _
                                     fGetValueAsBool    as Virtual_IsEmptyCell, _
                                     fSetValueAsLong    as Virtual_SetValueAsLong, _
                                     fSetValueAsDouble  as Virtual_SetValueAsDouble, _
                                     fSetValueAsBool    as Virtual_SetValueAsBool, _
                                     fGetValueAsCustom  as Virtual_GetValueAsCustom, _
                                     fSetValueAsCustom  as Virtual_SetValueAsCustom, _
                                     fSetView           as Virtual_SetView, _
                                     fGetView           as Virtual_GetView, _
                                     fClear             as Virtual_Clear, _
                                     fInsertRows        as Virtual_InsertRows, _
                                     fAppendRows        as Virtual_AppendRows, _
                                     fDeleteRows        as Virtual_InsertRows, _ 
                                     fInsertCols        as Virtual_InsertRows, _
                                     fAppendCols        as Virtual_AppendRows, _
                                     fDeleteCols        as Virtual_InsertRows, _
                                     fGetRowLabelValue  as Virtual_GetColLabelValue, _
                                     fGetColLabelValue  as Virtual_GetColLabelValue, _
                                     fSetRowLabelValue  as Virtual_SetRowLabelValue, _
                                     fSetColLabelValue  as Virtual_SetRowLabelValue, _
                                     fSetAttrProvider   as Virtual_SetAttrProvider, _
                                     fGetAttrProvider   as Virtual_GetAttrProvider, _
                                     fCanHaveAttributes as Virtual_CanHaveAttributes, _
                                     fGetAttr           as Virtual_GetAttr, _
                                     fSetAttr           as Virtual_SetAttr, _
                                     fSetRowAttr        as Virtual_SetRowAttr, _
                                     fsetColAttr        as Virtual_SetRowAttr)

_DF(wxGridTableBase_GetTypeName)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt) as _wxString ptr

_DF(wxGridTableBase_CanGetValueAs)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, typeName as _wxString ptr) as wxBool

_DF(wxGridTableBase_CanSetValueAs)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, typeName as _wxString ptr) as wxBool

_DF(wxGridTableBase_GetValueAsLong)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt) as wxLong

_DF(wxGridTableBase_GetValueAsDouble)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt) as wxDouble

_DF(wxGridTableBase_GetValueAsBool)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt) as wxBool

_DS(wxGridTableBase_SetValueAsLong)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, value as wxLong)

_DS(wxGridTableBase_SetValueAsDouble)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, value as wxDouble)

_DS(wxGridTableBase_SetValueAsBool)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, value as wxBool)

_DF(wxGridTableBase_GetValueAsCustom)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, typeName as _wxString ptr) as any ptr

_DS(wxGridTableBase_SetValueAsCustom)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, typeName as _wxString ptr, value as any ptr)

_DS(wxGridTableBase_SetView)(self as _wxGridTableBase ptr, grid as _wxGrid ptr)

_DF(wxGridTableBase_GetView)(self as _wxGridTableBase ptr) as _wxGrid ptr

_DS(wxGridTableBase_Clear)(self as _wxGridTableBase ptr)

_DF(wxGridTableBase_InsertRows)(self as _wxGridTableBase ptr,position as wxInt, numRows as wxInt) as wxBool

_DF(wxGridTableBase_AppendRows)(self as _wxGridTableBase ptr, numRows as wxInt) as wxBool

_DF(wxGridTableBase_DeleteRows)(self as _wxGridTableBase ptr,position as wxInt, numRows as wxInt) as wxBool

_DF(wxGridTableBase_InsertCols)(self as _wxGridTableBase ptr,position as wxInt,  numCols as wxInt) as wxBool

_DF(wxGridTableBase_AppendCols)(self as _wxGridTableBase ptr,  numCols as wxInt) as wxBool

_DF(wxGridTableBase_DeleteCols)(self as _wxGridTableBase ptr,position as wxInt, numCols as wxInt) as wxBool

_DF(wxGridTableBase_GetRowLabelValue)(self as _wxGridTableBase ptr, row as wxInt) as _wxString ptr

_DF(wxGridTableBase_GetColLabelValue)(self as _wxGridTableBase ptr, col as wxInt) as _wxString ptr

_DS(wxGridTableBase_SetRowLabelValue)(self as _wxGridTableBase ptr, row as wxInt, value as _wxString ptr)

_DS(wxGridTableBase_SetColLabelValue)(self as _wxGridTableBase ptr, col as wxInt, value as _wxString ptr)

_DS(wxGridTableBase_SetAttrProvider)(self as _wxGridTableBase ptr, ap as _wxGridCellAttrProvider ptr)

_DF(wxGridTableBase_GetAttrProvider)(self as _wxGridTableBase ptr) as _wxGridCellAttrProvider ptr

_DF(wxGridTableBase_CanHaveAttributes)(self as _wxGridTableBase ptr) as wxBool

_DF(wxGridTableBase_GetAttr)(self as _wxGridTableBase ptr, row as wxInt, col as wxInt, kind as wxAttrKind) as _wxGridCellAttr ptr

_DS(wxGridTableBase_SetAttr)(self as _wxGridTableBase ptr, attr as _wxGridCellAttr ptr, row as wxInt, col as wxInt)

_DS(wxGridTableBase_SetRowAttr)(self as _wxGridTableBase ptr, attr as _wxGridCellAttr ptr, row as wxInt)

_DS(wxGridTableBase_SetColAttr)(self as _wxGridTableBase ptr, attr as _wxGridCellAttr ptr, col as wxInt)


' class wxGridCellTextEditor
_DF(wxGridCellTextEditor_ctor) as _wxGridCellTextEditor ptr

_DF(GridCellTextEditor_GetWxClassInfo) as _wxClassInfo ptr

_DS(wxGridCellTextEditor_dtor)(self as _wxGridCellTextEditor ptr)

_DS(wxGridCellTextEditor_Create)(self as _wxGridCellTextEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DS(wxGridCellTextEditor_SetSize)(self as _wxGridCellTextEditor ptr, r as _wxRect ptr)

_DS(wxGridCellTextEditor_PaintBackground)(self as _wxGridCellTextEditor ptr, r as _wxRect ptr, attr as _wxGridCellAttr ptr)

_DF(wxGridCellTextEditor_IsAcceptedKey)(self as _wxGridCellTextEditor ptr, evnt as _wxKeyEvent ptr) as wxBool

_DS(wxGridCellTextEditor_BeginEdit)(self as _wxGridCellTextEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr)

_DF(wxGridCellTextEditor_EndEdit)(self as _wxGridCellTextEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr) as wxBool

_DS(wxGridCellTextEditor_Reset)(self as _wxGridCellTextEditor ptr)

_DS(wxGridCellTextEditor_StartingKey)(self as _wxGridCellTextEditor ptr, evnt as _wxKeyEvent ptr)

_DS(wxGridCellTextEditor_SetParameters)(self as _wxGridCellTextEditor ptr, param as _wxString ptr)

_DF(wxGridCellTextEditor_Clone)(self as _wxGridCellTextEditor ptr) as _wxGridCellEditor ptr


' class wxGridCellAttrProvider
_DF(wxGridCellAttrProvider_ctor) as _wxGridCellAttrProvider ptr

_DS(wxGridCellAttrProvider_dtor)(self as _wxGridCellAttrProvider ptr)

_DS(wxGridCellAttrProvider_RegisterVirtual)(self as _wxGridCellAttrProvider ptr, on_dispose as Virtual_Dispose, fGetAttr as Virtual_GetAttr, fSetAttr as Virtual_SetAttr, fSetRowAttr as Virtual_SetRowAttr, fSetrColAttr as Virtual_SetRowAttr)

_DF(wxGridCellAttrProvider_GetAttr)(self as _wxGridCellAttrProvider ptr, row as wxInt, col as wxInt, kind as wxAttrKind) as _wxGridCellAttr ptr

_DS(wxGridCellAttrProvider_SetAttr)(self as _wxGridCellAttrProvider ptr, attr as _wxGridCellAttr ptr, row as wxInt, col as wxInt)

_DS(wxGridCellAttrProvider_SetRowAttr)(self as _wxGridCellAttrProvider ptr, attr as _wxGridCellAttr ptr, row as wxInt)

_DS(wxGridCellAttrProvider_SetColAttr)(self as _wxGridCellAttrProvider ptr, attr as _wxGridCellAttr ptr, col as wxInt)

_DS(wxGridCellAttrProvider_UpdateAttrRows)(self as _wxGridCellAttrProvider ptr,position as wxInt, numRows as wxInt)

_DS(wxGridCellAttrProvider_UpdateAttrCols)(self as _wxGridCellAttrProvider ptr,position as wxInt, numCols as wxInt)


' class wxGridCellNumberEditor
_DF(GridCellNumberEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellNumberEditor_ctor)(min as wxInt, max as wxInt) as _wxGridCellNumberEditor ptr

_DS(wxGridCellNumberEditor_dtor)(self as _wxGridCellNumberEditor ptr)

_DS(wxGridCellNumberEditor_RegisterDisposable)(self as _wxGridCellNumberEditor ptr, on_dispose as Virtual_Dispose)

_DS(wxGridCellNumberEditor_Create)(self as _wxGridCellNumberEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DF(wxGridCellNumberEditor_IsAcceptedKey)(self as _wxGridCellNumberEditor ptr, evnt as _wxKeyEvent ptr) as wxBool

_DS(wxGridCellNumberEditor_BeginEdit)(self as _wxGridCellNumberEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr)

_DF(wxGridCellNumberEditor_EndEdit)(self as _wxGridCellNumberEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr) as wxBool

_DS(wxGridCellNumberEditor_Reset)(self as _wxGridCellNumberEditor ptr)

_DS(wxGridCellNumberEditor_StartingKey)(self as _wxGridCellNumberEditor ptr, evnt as _wxKeyEvent ptr)

_DS(wxGridCellNumberEditor_SetParameters)(self as _wxGridCellNumberEditor ptr, param as _wxString ptr)

_DF(wxGridCellNumberEditor_Clone)(self as _wxGridCellNumberEditor ptr) as _wxGridCellEditor ptr


' wxGridCellFloatEditor
_DF(GridCellFloatEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellFloatEditor_ctor)(w as wxInt, precision as wxInt) as _wxGridCellFloatEditor ptr

_DS(wxGridCellFloatEditor_dtor)(self as _wxGridCellFloatEditor ptr)

_DS(wxGridCellFloatEditor_Create)(self as _wxGridCellFloatEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DF(wxGridCellFloatEditor_IsAcceptedKey)(self as _wxGridCellFloatEditor ptr, evnt as _wxKeyEvent ptr) as wxBool

_DS(wxGridCellFloatEditor_BeginEdit)(self as _wxGridCellFloatEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr)

_DF(wxGridCellFloatEditor_EndEdit)(self as _wxGridCellFloatEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr) as wxBool

_DS(wxGridCellFloatEditor_Reset)(self as _wxGridCellFloatEditor ptr)

_DS(wxGridCellFloatEditor_StartingKey)(self as _wxGridCellFloatEditor ptr, evnt as _wxKeyEvent ptr)

_DS(wxGridCellFloatEditor_SetParameters)(self as _wxGridCellFloatEditor ptr, param as _wxString ptr)

_DF(wxGridCellFloatEditor_Clone)(self as _wxGridCellFloatEditor ptr) as _wxGridCellEditor ptr


' class wxGridCellBoolEditor
_DF(GridCellBoolEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellBoolEditor_ctor) as _wxGridCellBoolEditor ptr

_DS(wxGridCellBoolEditor_dtor)(self as _wxGridCellBoolEditor ptr)

_DS(wxGridCellBoolEditor_UseStringValues)(valueTrue as _wxString ptr, valueFalse as _wxString ptr)

_DF(wxGridCellBoolEditor_IsTrueValue)(value as _wxString ptr) as wxBool

_DS(wxGridCellBoolEditor_RegisterDisposable)(self as _wxGridCellBoolEditor ptr, on_dispose as Virtual_Dispose)

_DS(wxGridCellBoolEditor_Create)(self as _wxGridCellBoolEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DS(wxGridCellBoolEditor_SetSize)(self as _wxGridCellBoolEditor ptr, r as _wxRect ptr)

_DF(wxGridCellBoolEditor_IsAcceptedKey)(self as _wxGridCellBoolEditor ptr, evnt as _wxKeyEvent ptr) as wxBool

_DS(wxGridCellBoolEditor_BeginEdit)(self as _wxGridCellBoolEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr)

_DF(wxGridCellBoolEditor_EndEdit)(self as _wxGridCellBoolEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr) as wxBool

_DS(wxGridCellBoolEditor_Reset)(self as _wxGridCellBoolEditor ptr)

_DS(wxGridCellBoolEditor_StartingClick)(self as _wxGridCellFloatEditor ptr)

_DF(wxGridCellBoolEditor_Clone)(self as _wxGridCellBoolEditor ptr) as _wxGridCellEditor ptr


' class wxGridCellChoiceEditor
_DF(GridCellChoiceEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellChoiceEditor_ctor)(choices as _wxArrayString ptr, allowothers as wxBool) as _wxGridCellChoiceEditor ptr

_DS(wxGridCellChoiceEditor_dtor)(self as _wxGridCellChoiceEditor ptr)

_DS(wxGridCellChoiceEditor_RegisterDisposable)(self as _wxGridCellChoiceEditor ptr, on_dispose as Virtual_Dispose)

_DS(wxGridCellChoiceEditor_Create)(self as _wxGridCellChoiceEditor ptr, parent as _wxWindow ptr, id as wxWindowID, evh as _wxEvtHandler ptr)

_DS(wxGridCellChoiceEditor_PaintBackground)(self as _wxGridCellChoiceEditor ptr, r as _wxRect ptr, attr as _wxGridCellAttr ptr)

_DS(wxGridCellChoiceEditor_BeginEdit)(self as _wxGridCellChoiceEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr)

_DF(wxGridCellChoiceEditor_EndEdit)(self as _wxGridCellChoiceEditor ptr, row as wxInt, col as wxInt, grid as _wxGrid ptr) as wxBool

_DS(wxGridCellChoiceEditor_Reset)(self as _wxGridCellChoiceEditor ptr)

_DS(wxGridCellChoiceEditor_SetParameters)(self as _wxGridCellChoiceEditor ptr, param as _wxString ptr)

_DF(wxGridCellChoiceEditor_Clone)(self as _wxGridCellChoiceEditor ptr) as _wxGridCellEditor ptr

' class wxGridCellStringRenderer
_DF(wxGridCellStringRenderer_ctor) as _wxGridCellStringRenderer ptr

_DS(wxGridCellStringRenderer_dtor)(self as _wxGridCellStringRenderer ptr)

_DS(wxGridCellStringRenderer_RegisterVirtual)(self as _wxGridCellStringRenderer ptr, on_dispose as Virtual_Dispose, fDraw as Virtual_Draw, fGetBestSize as Virtual_GetBestSize, fClone as Virtual_RendererClone)

_DS(wxGridCellStringRenderer_Draw)(self as _wxGridCellStringRenderer ptr, grid as _wxGrid ptr, attr as _wxGridCellAttr ptr, dc as _wxDC ptr, r as _wxRect ptr, row as wxInt, col as wxInt, isSelected as wxBool)

_DS(wxGridCellStringRenderer_GetBestSize)(self as _wxGridCellStringRenderer ptr, grid as _wxGrid ptr, attr as _wxGridCellAttr ptr, dc as _wxDC ptr, row as wxInt, col as wxInt, size as _wxSize ptr)

_DF(wxGridCellStringRenderer_Clone)(self as _wxGridCellStringRenderer ptr) as _wxGridCellRenderer ptr


' class wxGridCellNumberRenderer
_DF(wxGridCellNumberRenderer_ctor) as _wxGridCellNumberRenderer ptr

_DS(wxGridCellNumberRenderer_dtor)(self as _wxGridCellNumberRenderer ptr)

_DS(wxGridCellNumberRenderer_RegisterVirtual)(self as _wxGridCellNumberRenderer ptr, _
                                              on_dispose   as Virtual_Dispose, _
                                              fDraw        as Virtual_Draw, _
                                              fGetBestSize as Virtual_GetBestSize, _
                                              fClone       as Virtual_RendererClone)

_DS(wxGridCellNumberRenderer_Draw)(self as _wxGridCellNumberRenderer ptr, grid as _wxGrid ptr, attr as _wxGridCellAttr ptr, dc as _wxDC ptr, r as _wxRect ptr, row as wxInt, col as wxInt, IsSelected as wxBool)

_DS(wxGridCellNumberRenderer_GetBestSize)(self as _wxGridCellNumberRenderer ptr, grid as _wxGrid ptr, attrr as _wxGridCellAttr ptr, dc as _wxDC ptr, row as wxInt, col as wxInt, size as _wxSize ptr)

_DF(wxGridCellNumberRenderer_Clone)(self as _wxGridCellNumberRenderer ptr) as _wxGridCellRenderer ptr


' class wxGridCellFloatRenderer
_DF(wxGridCellFloatRenderer_ctor)(w as wxInt, precision as wxInt) as _wxGridCellFloatRenderer ptr

_DS(wxGridCellFloatRenderer_dtor)(self as _wxGridCellFloatRenderer ptr)

_DS(wxGridCellFloatRenderer_RegisterVirtual)(self as _wxGridCellFloatRenderer ptr,  _
                                             on_dispose as Virtual_Dispose, _
                                             fDraw as Virtual_Draw, _
                                             fGetBestSize as Virtual_GetBestSize, _
                                             fClone as Virtual_RendererClone)



_DS(wxGridCellFloatRenderer_Draw)(self as _wxGridCellFloatRenderer ptr, grid as _wxGrid ptr, attr as _wxGridCellAttr ptr, dc as _wxDC ptr, r as _wxRect ptr, row as wxInt, col as wxInt, IsSelected as wxBool)

_DS(wxGridCellFloatRenderer_GetBestSize)(self as _wxGridCellFloatRenderer ptr, grid as _wxGrid ptr, attrr as _wxGridCellAttr ptr, dc as _wxDC ptr, row as wxInt, col as wxInt, size as _wxSize ptr)

_DF(wxGridCellFloatRenderer_Clone)(self as _wxGridCellFloatRenderer ptr) as _wxGridCellRenderer ptr

_DF(wxGridCellFloatRenderer_GetWidth)(self as _wxGridCellFloatRenderer ptr) as wxInt

_DS(wxGridCellFloatRenderer_SetWidth)(self as _wxGridCellFloatRenderer ptr, w as wxInt)

_DF(wxGridCellFloatRenderer_GetPrecision)(self as _wxGridCellFloatRenderer ptr) as wxInt

_DS(wxGridCellFloatRenderer_SetPrecision)(self as _wxGridCellFloatRenderer ptr, precision as wxInt)

_DS(wxGridCellFloatRenderer_SetParameters)(self as _wxGridCellFloatRenderer ptr, param as _wxString ptr)


' class wxGridCellBoolRenderer
_DF(wxGridCellBoolRenderer_ctor) as _wxGridCellBoolRenderer ptr

_DS(wxGridCellBoolRenderer_dtor)(self as _wxGridCellBoolRenderer ptr)

_DS(wxGridCellBoolRenderer_RegisterDisposable)(self as _wxGridCellBoolRenderer ptr, on_dispose as Virtual_Dispose)

_DS(wxGridCellBoolRenderer_Draw)(self as _wxGridCellBoolRenderer ptr, grid as _wxGrid ptr, attr as _wxGridCellAttr ptr, dc as _wxDC ptr, r as _wxRect ptr, row as wxInt, col as wxInt, IsSelected as wxBool)

_DS(wxGridCellBoolRenderer_GetBestSize)(self as _wxGridCellBoolRenderer ptr, grid as _wxGrid ptr, attrr as _wxGridCellAttr ptr, dc as _wxDC ptr, row as wxInt, col as wxInt, size as _wxSize ptr)

_DF( wxGridCellBoolRenderer_Clone)(self as _wxGridCellBoolRenderer ptr) as _wxGridCellRenderer ptr


' class wxGridCellRenderer
_DF(wxGridCellRenderer_ctor) as _wxGridCellRenderer ptr

_DS(wxGridCellRenderer_dtor)(self as _wxGridCellRenderer ptr)

_DS(wxGridCellRenderer_RegisterVirtual)(self as _wxGridCellRenderer ptr, _
                                        on_dispos as Virtual_Dispose, _
                                        fDraw as Virtual_Draw, _
                                        fGetBestSize as Virtual_GetBestSize, _
                                        fClone as Virtual_RendererClone)

_DF(GridCellEnumEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellAutoWrapStringEditor_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellEditor_GetClassInfoOnInstance)(obj as _wxGridCellEditor ptr) as _wxClassInfo ptr

_DF(GridCellRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellStringRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellNumberRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellFloatRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellBoolRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellEnumRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellDateTimeRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(GridCellAutoWrapStringRenderer_GetWxClassInfo) as _wxClassInfo ptr

_DF(wxGridCellRenderer_GetClassInfoOnInstance)(obj as _wxGridCellRenderer ptr) as _wxClassInfo ptr

#endif ' __grid_bi__
