#ifndef __html_bi__
#define __html_bi__

#include once "common.bi"

type Virtual_OnLinkClicked    as sub      APICALL (as _wxHtmlLinkInfo ptr)
type Virtual_OnSetTitle       as sub      APICALL (as _wxString ptr )
type Virtual_OnCellMouseHover as sub      APICALL (as _wxHtmlCell ptr, as wxCoord, as wxCoord)
type Virtual_OnCellClicked    as function APICALL (as _wxHtmlCell ptr, as wxCoord, as wxCoord, as _wxMouseEvent ptr) as wxBool
type Virtual_OnOpeningURL     as function APICALL (as wxHtmlURLType, as _wxString ptr, as _wxString ptr) as wxHtmlOpeningStatus
type Virtual_LoadFile         as function APICALL (filename as _wxString ptr) as wxInt
type Virtual_LoadPage         as function APICALL (location as _wxString ptr) as wxInt

type Virtual_GetSupportedTags as function APICALL as _DisposableStringBox ptr
type Virtual_GetHandleTag     as function APICALL (varib as _wxHtmlTag ptr) as wxInt


_DF(wxHtmlWindow_ctor)() as _wxHtmlWindow ptr

_DF(wxHtmlWindow_ctor2)(parent  as _wxWindow ptr, _
                        id      as  wxWindowID, _
                        p       as _wxPoint ptr, _
                        size    as _wxSize ptr, _
                        style   as  wxUInt=0, _
                        nameArg as _wxString ptr=WX_NULL) as _wxHtmlWindow ptr

_DS(wxHtmlWindow_RegisterVirtual)(self              as _wxHtmlWindow ptr, _
                                  on_LinkClicked    as Virtual_OnLinkClicked, _
                                  on_SetTitle       as Virtual_OnSetTitle, _
                                  on_CellMouseHover as Virtual_OnCellMouseHover, _
                                  on_CellClicked    as Virtual_OnCellClicked, _
                                  on_OpeningURL     as Virtual_OnOpeningURL, _
                                  fLoadFile         as Virtual_LoadFile, _
                                  fLoadPage         as Virtual_LoadPage)

_DF(wxHtmlWindow_Create)(self    as _wxHtmlWindow ptr, _
                         parent  as _wxWindow ptr, _
                         id      as  wxWindowID, _
                         p       as _wxPoint ptr, _
                         size    as _wxSize  ptr, _
                         style   as  wxUInt, _
                         nameArg as _wxString ptr) as wxBool

_DF(wxHtmlWindow_SetPage)(self as _wxHtmlWindow ptr, source as _wxString ptr) as wxBool

_DF(wxHtmlWindow_AppendToPage)(self as _wxHtmlWindow ptr, source as _wxString ptr) as wxBool

_DF(wxHtmlWindow_LoadPage)(self as _wxHtmlWindow ptr, location as _wxString ptr) as wxBool

' This calls the original implementation, not the callback.
_DF(wxHtmlWindow_LoadFile)(self as _wxHtmlWindow ptr, wfilename as _wxString ptr) as wxBool

_DF(wxHtmlWindow_GetOpenedPage)(self as _wxHtmlWindow ptr) as _wxString ptr

_DF(wxHtmlWindow_GetOpenedAnchor)(self as _wxHtmlWindow ptr) as _wxString ptr

_DF(wxHtmlWindow_GetOpenedPageTitle)(self as _wxHtmlWindow ptr) as _wxString ptr

_DS(wxHtmlWindow_SetRelatedFrame)(self as _wxHtmlWindow ptr, frame as _wxFrame ptr, fmt as _wxString ptr)

_DF(wxHtmlWindow_GetRelatedFrame)(self as _wxHtmlWindow ptr) as _wxFrame ptr

_DS(wxHtmlWindow_SetRelatedStatusBar)(self as _wxHtmlWindow ptr, sb as wxInt)

_DS(wxHtmlWindow_SetFonts)(self as _wxHtmlWindow ptr, normal_face as _wxString ptr, fixed_face as _wxString ptr, sizes as wxInt ptr)

_DS(wxHtmlWindow_SetBorders)(self as _wxHtmlWindow ptr, border as wxInt)

_DS(wxHtmlWindow_ReadCustomization)(self as _wxHtmlWindow ptr, cfg as _wxConfigBase ptr, path as _wxString ptr)

_DS(wxHtmlWindow_WriteCustomization)(self as _wxHtmlWindow ptr, cfg as _wxConfigBase ptr, path as _wxString ptr)

_DF(wxHtmlWindow_HistoryBack)(self as _wxHtmlWindow ptr) as wxBool

_DF(wxHtmlWindow_HistoryForward)(self as _wxHtmlWindow ptr) as wxBool

_DF(wxHtmlWindow_HistoryCanBack)(self as _wxHtmlWindow ptr) as wxBool

_DF(wxHtmlWindow_HistoryCanForward)(self as _wxHtmlWindow ptr) as wxBool

_DS(wxHtmlWindow_HistoryClear)(self as _wxHtmlWindow ptr)

_DF(wxHtmlWindow_GetInternalRepresentation)(self as _wxHtmlWindow ptr) as _wxHtmlContainerCell ptr 

_DS(wxHtmlWindow_AddFilter)(filter as _wxHtmlFilter ptr )

_DF(wxHtmlWindow_GetParser)(self as _wxHtmlWindow ptr) as _wxHtmlWinParser ptr

_DS(wxHtmlWindow_AddProcessor)(self as _wxHtmlWindow ptr, processor as _wxHtmlProcessor ptr)

_DS(wxHtmlWindow_AddGlobalProcessor)(processor as _wxHtmlProcessor ptr)

_DF(wxHtmlWindow_AcceptsFocusFromKeyboard)(self as _wxHtmlWindow ptr) as wxBool

_DS(wxHtmlWindow_OnSetTitle)(self as _wxHtmlWindow ptr, title as _wxString ptr)

_DF(wxHtmlWindow_OnCellClicked)(self as _wxHtmlWindow ptr, cell as _wxHtmlCell ptr, x as wxCoord, y as wxCoord, evnt as _wxMouseEvent ptr) as wxBool

_DS(wxHtmlWindow_OnLinkClicked)(self as _wxHtmlWindow ptr, link as _wxHtmlLinkInfo ptr)

_DF(wxHtmlWindow_OnOpeningURL)(self as _wxHtmlWindow ptr, typ as wxHtmlURLType, url as _wxString ptr, redirect as _wxString ptr) as wxHtmlOpeningStatus

_DS(wxHtmlWindow_SelectAll)(self as _wxHtmlWindow ptr)

_DS(wxHtmlWindow_SelectCells)(self as _wxHtmlWindow ptr, cf as _wxHtmlCell ptr, cl as _wxHtmlCell ptr)

_DS(wxHtmlWindow_SelectWord)(self as _wxHtmlWindow ptr, p as _wxPoint ptr)

_DS(wxHtmlWindow_SelectLine)(self as _wxHtmlWindow ptr, p as _wxPoint ptr)

_DF(wxHtmlWindow_HasSelection)(self as _wxHtmlWindow ptr) as wxBool

_DF(wxHtmlWindow_SelectionFromCell)(self as _wxHtmlWindow ptr) as _wxHtmlCell ptr

_DF(wxHtmlWindow_SelectionToCell)(self as _wxHtmlWindow ptr) as _wxHtmlCell ptr

_DF(wxHtmlWindow_SelectionPosition)(self as _wxHtmlWindow ptr, fromX as wxInt ptr, fromY as wxInt ptr, toX as wxInt ptr, toY as wxInt ptr) as wxBool

_DF(wxHtmlWindow_ToText)(self as _wxHtmlWindow ptr) as _wxString ptr

_DF(wxHtmlWindow_SelectionToText)(self as _wxHtmlWindow ptr) as _wxString ptr

_DF(HtmlFontCell_GetWxClassInfo) as _wxClassInfo ptr

' class wxHtmlFontCel
_DF(wxHtmlFontCell_ctor)(font as _wxFont ptr) as _wxHtmlFontCell ptr

_DS(wxHtmlFontCell_Draw)(self as _wxHtmlFontCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlFontCell_DrawInvisible)(self as _wxHtmlFontCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, info as _wxHtmlRenderingInfo ptr)

_DF(HtmlColourCell_GetWxClassInfo) as _wxClassInfo ptr

' class wxHtmlColourCell
_DF(wxHtmlColourCell_ctor)(col as _wxColour ptr, flags as wxInt) as _wxHtmlColourCell ptr

_DS(wxHtmlColourCell_Draw)(self as _wxHtmlColourCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlColourCell_DrawInvisible)(self as _wxHtmlColourCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, info as _wxHtmlRenderingInfo ptr)

' class wxHtmlLinkInfo
_DF(wxHtmlLinkInfo_ctor)() as _wxHtmlLinkInfo ptr

_DS(wxHtmlLinkInfo_SetEvent)(self as _wxHtmlLinkInfo ptr, me as _wxMouseEvent ptr)

_DS(wxHtmlLinkInfo_SetHtmlCell)(self as _wxHtmlLinkInfo ptr, cell as _wxHtmlCell ptr)

_DF(wxHtmlLinkInfo_GetHref)(self as _wxHtmlLinkInfo ptr) as _wxString ptr

_DF(wxHtmlLinkInfo_GetTarget)(self as _wxHtmlLinkInfo ptr) as _wxString ptr

_DF(wxHtmlLinkInfo_GetEvent)(self as _wxHtmlLinkInfo ptr) as _wxMouseEvent ptr

_DF(wxHtmlLinkInfo_GetHtmlCell)(self as _wxHtmlLinkInfo ptr) as _wxHtmlCell ptr

_DF(HtmlWidgetCell_GetWxClassInfo)() as _wxClassInfo ptr

' class wxHtmlWidgetCell
_DF(wxHtmlWidgetCell_ctor)(win as _wxWindow ptr, w as wxInt) as _wxHtmlWidgetCell ptr

_DS(wxHtmlWidgetCell_RegisterDispose)(self as _wxHtmlWidgetCell ptr, on_dispose as Virtual_Dispose)

_DS(wxHtmlWidgetCell_Draw)(self as _wxHtmlWidgetCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlWidgetCell_DrawInvisible)(self as _wxHtmlWidgetCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlWidgetCell_Layout)(self as _wxHtmlWidgetCell ptr, w as wxInt)

_DF(wxHtmlWidgetCell_GetWindow)(self as _wxHtmlWidgetCell ptr) as _wxWindow ptr

_DF(wxHtmlWidgetCell_Destroy)(self as _wxHtmlWidgetCell ptr) as wxBool

_DF(HtmlCell_GetWxClassInfo) as _wxClassInfo ptr

' class wxHtmlCell
_DF(wxHtmlCell_ctor)() as _wxHtmlCell ptr

_DS(wxHtmlCell_SetParent)(self as _wxHtmlCell ptr, parent as _wxHtmlContainerCell ptr)

_DF(wxHtmlCell_GetParent)(self as _wxHtmlCell ptr) as _wxHtmlContainerCell ptr

_DF(wxHtmlCell_GetPosX)(self as _wxHtmlCell ptr) as wxInt

_DF(wxHtmlCell_GetPosY)(self as _wxHtmlCell ptr) as wxInt

_DS(wxHtmlCell_GetAbsPos)(self as _wxHtmlCell ptr, rootCell as _wxHtmlCell ptr, x as wxInt ptr, y as wxInt ptr)

_DF(wxHtmlCell_GetWidth)(self as _wxHtmlCell ptr) as wxInt

_DF(wxHtmlCell_GetHeight)(self as _wxHtmlCell ptr) as wxInt

_DF(wxHtmlCell_GetDescent)(self as _wxHtmlCell ptr) as wxInt

_DF(wxHtmlCell_GetId)(self as _wxHtmlCell ptr) as _wxString ptr

_DS(wxHtmlCell_SetId)(self as _wxHtmlCell ptr, id as _wxString ptr)

_DF(wxHtmlCell_GetNext)(self as _wxHtmlCell ptr) as _wxHtmlCell ptr

_DS(wxHtmlCell_SetPos)(self as _wxHtmlCell ptr, x as wxInt, y as wxInt)

_DF(wxHtmlCell_GetLink)(self as _wxHtmlCell ptr) as _wxHtmlLinkInfo ptr

_DS(wxHtmlCell_SetLink)(self as _wxHtmlCell ptr, link as _wxHtmlLinkInfo ptr)

_DS(wxHtmlCell_SetNext)(self as _wxHtmlCell ptr, cell as _wxHtmlCell ptr)

_DS(wxHtmlCell_Layout)(self as _wxHtmlCell ptr, w as wxInt)

_DS(wxHtmlCell_Draw)(self as _wxHtmlCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt,  view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlCell_DrawInvisible)(self as _wxHtmlCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt,  info as _wxHtmlRenderingInfo ptr)

_DF(wxHtmlCell_Find)(self as _wxHtmlCell ptr, cond as wxInt, param as any ptr) as _wxHtmlCell ptr

_DS(wxHtmlCell_OnMouseClick)(self as _wxHtmlCell ptr, parent as _wxWindow ptr, x as wxInt, y as wxInt, ev as _wxMouseEvent ptr)

_DF(wxHtmlCell_AdjustPagebreak)(self as _wxHtmlCell ptr, pagebreak as wxInt ptr) as wxBool

_DS(wxHtmlCell_SetCanLiveOnPagebreak)(self as _wxHtmlCell ptr, can as wxBool)

_DF(wxHtmlCell_IsTerminalCell)(self as _wxHtmlCell ptr) as wxBool

_DF(wxHtmlCell_IsFormattingCell)(self as _wxHtmlCell ptr) as wxBool

_DF(wxHtmlCell_FindCellByPos)(self as _wxHtmlCell ptr, x as wxCoord, y as wxCoord, mode as wxInt) as _wxHtmlCell ptr

_DF(wxHtmlCell_GetFirstChild)(self as _wxHtmlCell ptr) as _wxHtmlCell ptr

_DF(wxHtmlCell_GetFirstTerminal)(self as _wxHtmlCell ptr) as _wxHtmlCell ptr

_DF(wxHtmlCell_GetLastTerminal)(self as _wxHtmlCell ptr) as _wxHtmlCell ptr

_DF(wxHtmlCell_GetRootCell)(self as _wxHtmlCell ptr) as _wxHtmlCell ptr

_DF(wxHtmlCell_IsBefore)(self as _wxHtmlCell ptr, other as _wxHtmlCell ptr) as wxBool

_DF(wxHtmlWindow_ConvertToText)(self as _wxHtmlCell ptr) as _wxString ptr

_DF(HtmlWordCell_GetWxClassInfo) as _wxClassInfo ptr

' class cwxHtmlWordCell
_DF(wxHtmlWordCell_ctor)(word as _wxString ptr, dc as _wxDC ptr) as _wxHtmlWordCell ptr

_DS(wxHtmlWordCell_Draw)(self as _wxHtmlWordCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DF(HtmlContainerCell_GetWxClassInfo) as _wxClassInfo ptr

' class wxHtmlContainerCell
_DF(wxHtmlContainerCell_ctor)(parent as _wxHtmlContainerCell ptr) as _wxHtmlContainerCell ptr

_DS(wxHtmlContainerCell_Layout)(self as _wxHtmlContainerCell ptr, w as wxInt)

_DS(wxHtmlContainerCell_Draw)(self as _wxHtmlContainerCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt, view_y1 as wxInt, view_y2 as wxInt, info as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlContainerCell_DrawInvisible)(self as _wxHtmlContainerCell ptr, dc as _wxDC ptr, x as wxInt, y as wxInt,  info as _wxHtmlRenderingInfo ptr)

_DF(wxHtmlContainerCell_AdjustPagebreak)(self as _wxHtmlContainerCell ptr, pagebreak as wxInt ptr) as wxBool

_DS(wxHtmlContainerCell_InsertCell)(self as _wxHtmlContainerCell ptr, cell as _wxHtmlCell ptr)

_DS(wxHtmlContainerCell_SetAlignHor)(self as _wxHtmlContainerCell ptr, alignH as wxInt)

_DF(wxHtmlContainerCell_GetAlignHor)(self as _wxHtmlContainerCell ptr) as wxInt

_DS(wxHtmlContainerCell_SetAlignVer)(self as _wxHtmlContainerCell ptr, alignV as wxInt)

_DF(wxHtmlContainerCell_GetAlignVer)(self as _wxHtmlContainerCell ptr) as wxInt

_DS(wxHtmlContainerCell_SetIndent)(self as _wxHtmlContainerCell ptr, i as wxInt, what as wxInt, units as wxInt)

_DF(wxHtmlContainerCell_GetIndent)(self as _wxHtmlContainerCell ptr, indent as wxInt) as wxInt

_DF(wxHtmlContainerCell_GetIndentUnits)(self as _wxHtmlContainerCell ptr,idex as wxInt) as wxInt

_DS(wxHtmlContainerCell_SetAlign)(self as _wxHtmlContainerCell ptr, tag as _wxHtmlTag ptr)

_DS(wxHtmlContainerCell_SetWidthFloat)(self as _wxHtmlContainerCell ptr, w as wxInt, units as wxInt)

_DS(wxHtmlContainerCell_SetWidthFloatTag)(self as _wxHtmlContainerCell ptr, tag as _wxHtmlTag ptr, pixel_scale as wxDouble)

_DS(wxHtmlContainerCell_SetMinHeight)(self as _wxHtmlContainerCell ptr, h as wxInt, align as wxInt)

_DS(wxHtmlContainerCell_SetBackgroundColour)(self as _wxHtmlContainerCell ptr, col as _wxColour ptr)

_DF(wxHtmlContainerCell_GetBackgroundColour)(self as _wxHtmlContainerCell ptr) as _wxColour ptr

_DS(wxHtmlContainerCell_SetBorder)(self as _wxHtmlContainerCell ptr, col1 as _wxColour ptr, col2 as _wxColour ptr)

_DF(wxHtmlContainerCell_GetLink)(self as _wxHtmlContainerCell ptr, x as wxInt, y as wxInt) as _wxHtmlLinkInfo ptr

_DF(wxHtmlContainerCell_Find)(self as _wxHtmlContainerCell ptr, cond as wxInt, param as any ptr) as _wxHtmlCell ptr

_DS(wxHtmlContainerCell_OnMouseClick)(self as _wxHtmlContainerCell ptr, parent as _wxWindow ptr, x as wxInt, y as wxInt, ev as _wxMouseEvent ptr)

_DS(wxHtmlTag_dtor)(self as _wxHtmlTag ptr)

_DF(wxHtmlTag_GetParent)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetFirstSibling)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetLastSibling)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetChildren)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetPreviousSibling)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetNextSibling)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetNextTag)(self as _wxHtmlTag ptr) as _wxHtmlTag ptr

_DF(wxHtmlTag_GetName)(self as _wxHtmlTag ptr) as _wxString ptr

_DF(wxHtmlTag_HasParam)(self as _wxHtmlTag ptr, par as _wxString ptr) as wxBool

_DF(wxHtmlTag_GetParam)(self as _wxHtmlTag ptr, par as _wxString ptr, with_commas as wxBool ) as _wxString ptr

_DF(wxHtmlTag_GetParamAsColour)(self as _wxHtmlTag ptr, par as _wxString ptr, col as _wxColour ptr) as wxBool

_DF(wxHtmlTag_GetParamAsInt)(self as _wxHtmlTag ptr, par as _wxString ptr, clr as wxInt ptr) as wxBool

_DF(wxHtmlTag_GetAllParams)(self as _wxHtmlTag ptr) as _wxString ptr

_DF(wxHtmlTag_HasEnding)(self as _wxHtmlTag ptr) as wxBool

_DF(wxHtmlTag_GetBeginPos)(self as _wxHtmlTag ptr) as wxInt

_DF(wxHtmlTag_GetEndPos1)(self as _wxHtmlTag ptr)  as wxInt

_DF(wxHtmlTag_GetEndPos2)(self as _wxHtmlTag ptr) as wxInt

_DF(wxHtmlFilter_CanRead)(self as _wxHtmlFilter ptr, file as _wxFSFile ptr) as wxBool

_DF(wxHtmlFilter_ReadFile)(self as _wxHtmlFilter ptr, file as _wxFSFile ptr) as _wxString ptr

_DF(wxHtmlFilterPlainText_CanRead)(self as _wxHtmlFilterPlainText ptr, file as _wxFSFile ptr) as wxBool

_DF(wxHtmlFilterPlainText_ReadFile)(self as _wxHtmlFilterPlainText ptr, file as _wxFSFile ptr) as _wxString ptr

_DF(wxHtmlFilterHTML_CanRead)(self as _wxHtmlFilterHTML ptr, file as _wxFSFile ptr) as wxBool

_DF(wxHtmlFilterHTML_ReadFile)(self as _wxHtmlFilterHTML ptr, file as _wxFSFile ptr) as _wxString ptr

' wxHtmlTagsModule
_DF(wxHtmlTagsModule_ctor)() as _wxHtmlTagsModule ptr

_DF(wxHtmlTagsModule_OnInit)(self as _wxHtmlTagsModule ptr) as wxBool

_DS(wxHtmlTagsModule_OnExit)(self as _wxHtmlTagsModule ptr)

_DS(wxHtmlTagsModule_FillHandlersTable)(self as _wxHtmlTagsModule ptr, parser as _wxHtmlWinParser ptr)

' class wxHtmlWinParser
_DF(wxHtmlWinParser_ctor)(win as _wxHtmlWindow ptr) as _wxHtmlWinParser ptr

_DS(wxHtmlWinParser_InitParser)(self as _wxHtmlWinParser ptr, src as _wxString ptr)

_DS(wxHtmlWinParser_DoneParser)(self as _wxHtmlWinParser ptr)

_DF(wxHtmlWinParser_GetProduct)(self as _wxHtmlWinParser ptr) as _wxObject ptr

_DF(wxHtmlWinParser_OpenURL)(self as _wxHtmlWinParser ptr, typ as wxHtmlURLType, url as _wxString ptr) as _wxFSFile ptr 

_DS(wxHtmlWinParser_SetDC)(self as _wxHtmlWinParser ptr, dc as _wxDC ptr, pixelscale as wxDouble)

_DF(wxHtmlWinParser_GetDC)(self as _wxHtmlWinParser ptr) as _wxDC ptr

_DF(wxHtmlWinParser_GetPixelScale)(self as _wxHtmlWinParser ptr) as wxDouble

_DF(wxHtmlWinParser_GetCharHeight)(self as _wxHtmlWinParser ptr) as wxInt

_DF(wxHtmlWinParser_GetCharWidth)(self as _wxHtmlWinParser ptr) as wxInt

_DF(wxHtmlWinParser_GetWindow)(self as _wxHtmlWinParser ptr) as _wxHtmlWindow ptr

_DS(wxHtmlWinParser_SetFonts)(self as _wxHtmlWinParser ptr, normalFace as _wxString ptr, fixedFace as _wxString ptr, sizes as wxInt ptr)

_DS(wxHtmlWinParser_AddModule)(self as _wxHtmlWinParser ptr, module as _wxHtmlTagsModule ptr)

_DS(wxHtmlWinParser_RemoveModule)(self as _wxHtmlWinParser ptr, module as _wxHtmlTagsModule ptr)

_DF(wxHtmlWinParser_GetContainer)(self as _wxHtmlWinParser ptr) as _wxHtmlContainerCell ptr

_DF(wxHtmlWinParser_OpenContainer)(self as _wxHtmlWinParser ptr) as _wxHtmlContainerCell ptr

_DF(wxHtmlWinParser_SetContainer)(self as _wxHtmlWinParser ptr, cell as _wxHtmlContainerCell ptr) as _wxHtmlContainerCell ptr

_DF(wxHtmlWinParser_CloseContainer)(self as _wxHtmlWinParser ptr) as _wxHtmlContainerCell ptr

_DF(wxHtmlWinParser_GetFontSize)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetFontSize)(self as _wxHtmlWinParser ptr, size as wxInt)

_DF(wxHtmlWinParser_GetFontBold)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetFontBold)(self as _wxHtmlWinParser ptr, b as wxInt)

_DF(wxHtmlWinParser_GetFontItalic)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetFontItalic)(self as _wxHtmlWinParser ptr, i as wxInt)

_DF(wxHtmlWinParser_GetFontUnderlined)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetFontUnderlined)(self as _wxHtmlWinParser ptr, u as wxInt)

_DF(wxHtmlWinParser_GetFontFixed)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetFontFixed)(self as _wxHtmlWinParser ptr, f as wxInt)

_DF(wxHtmlWinParser_GetFontFace)(self as _wxHtmlWinParser ptr) as _wxString ptr

_DS(wxHtmlWinParser_SetFontFace)(self as _wxHtmlWinParser ptr, face as _wxString ptr)

_DF(wxHtmlWinParser_GetAlign)(self as _wxHtmlWinParser ptr) as wxInt

_DS(wxHtmlWinParser_SetAlign)(self as _wxHtmlWinParser ptr, align as wxInt)

_DF(wxHtmlWinParser_GetLinkColor)(self as _wxHtmlWinParser ptr) as _wxColour ptr 

_DS(wxHtmlWinParser_SetLinkColor)(self as _wxHtmlWinParser ptr, col as _wxColour ptr)

_DF(wxHtmlWinParser_GetActualColor)(self as _wxHtmlWinParser ptr) as _wxColour ptr 

_DS(wxHtmlWinParser_SetActualColor)(self as _wxHtmlWinParser ptr, col as _wxColour ptr)

_DF(wxHtmlWinParser_GetLink)(self as _wxHtmlWinParser ptr) as _wxHtmlLinkInfo ptr

_DS(wxHtmlWinParser_SetLink)(self as _wxHtmlWinParser ptr, link as _wxHtmlLinkInfo ptr)

_DF(wxHtmlWinParser_CreateCurrentFont)(self as _wxHtmlWinParser ptr) as _wxFont ptr

' class _wxHtmlTagHandler
_DF(wxHtmlTagHandler_CTor)() as _wxHtmlTagHandler ptr

_DS(wxHtmlTagHandler_RegisterVirtual)(self as _wxHtmlTagHandler ptr, _
                                      on_dispose           as Virtual_Dispose, _
                                      getSupportedTagsCall as Virtual_GetSupportedTags, _
                                      getHandleTagCall     as Virtual_GetHandleTag)

_DF(wxHtmlTagHandler_GetParser)(self as _wxHtmlTagHandler ptr) as _wxHtmlParser ptr

_DF(wxHtmlTagHandler_GetWParser)(self as _wxHtmlTagHandler ptr) as _wxHtmlParser ptr

_DS(wxHtmlTagHandler_ParseInner)(self as _wxHtmlTagHandler ptr, tag as _wxHtmlTag ptr)

_DS(wxHtmlTagHandler_SetParser)(self as _wxHtmlTagHandler ptr, parser as _wxHtmlParser ptr)

' class _wxHtmlEntitiesParser
_DF(wxHtmlEntitiesParser_ctor)() as _wxHtmlEntitiesParser ptr

_DS(wxHtmlEntitiesParser_dtor)(self as _wxHtmlEntitiesParser ptr)

_DS(wxHtmlEntitiesParser_SetEncoding)(self as _wxHtmlEntitiesParser ptr, enc as wxFontEncoding)

_DF(wxHtmlEntitiesParser_Parse)(self as _wxHtmlEntitiesParser ptr, in as _wxString ptr) as _wxString ptr

_DF(wxHtmlEntitiesParser_GetEntityChar)(self as _wxHtmlEntitiesParser ptr, entity as _wxString ptr) as wxChar

_DF(wxHtmlEntitiesParser_GetCharForCode)(self as _wxHtmlEntitiesParser ptr, code as wxChar) as wxChar

_DF(wxHtmlParser_IsWinParser)(self as _wxHtmlParser ptr) as wxBool

_DS(wxHtmlParser_SetFS)(self as _wxHtmlParser ptr, fs as _wxFileSystem ptr)

_DF(wxHtmlParser_GetFS)(self as _wxHtmlParser ptr) as _wxFileSystem ptr

_DF(wxHtmlParser_OpenURL)(self as _wxHtmlParser ptr, typ as wxHtmlURLType, url as _wxString ptr) as _wxFSFile ptr

_DF(wxHtmlParser_Parse)(self as _wxHtmlParser ptr, source as _wxString ptr) as _wxObject ptr

_DS(wxHtmlParser_InitParser)(self as _wxHtmlParser ptr, source as _wxString ptr)

_DS(wxHtmlParser_DoneParser)(self as _wxHtmlParser ptr)

_DS(wxHtmlParser_StopParsing)(self as _wxHtmlParser ptr)

_DS(wxHtmlParser_DoParsing)(self as _wxHtmlParser ptr, beginPos as wxInt, endPos as wxInt)

_DS(wxHtmlParser_DoParsingAll)(self as _wxHtmlParser ptr)

_DF(wxHtmlParser_GetCurrentTag)(self as _wxHtmlParser ptr) as _wxHtmlTag ptr

_DF(wxHtmlParser_GetProduct)(self as _wxHtmlParser ptr) as _wxObject ptr

_DS(wxHtmlParser_AddTagHandler)(self as _wxHtmlParser ptr, handler as _wxHtmlTagHandler ptr)

_DS(wxHtmlParser_PushTagHandler)(self as _wxHtmlParser ptr, handler as _wxHtmlTagHandler ptr, tags as _wxString ptr)

_DS(wxHtmlParser_PopTagHandler)(self as _wxHtmlParser ptr)

_DF(wxHtmlParser_GetSource)(self as _wxHtmlParser ptr) as _wxString ptr 

_DS(wxHtmlParser_SetSource)(self as _wxHtmlParser ptr, src  as _wxString ptr)

_DS(wxHtmlParser_SetSourceAndSaveState)(self as _wxHtmlParser ptr, src as _wxString ptr)

_DF(wxHtmlParser_RestoreState)(self as _wxHtmlParser ptr) as wxBool

_DF(wxHtmlParser_ExtractCharsetInformation)(self as _wxHtmlParser ptr, markup as _wxString ptr) as _wxString ptr

_DF(wxHtmlProcessor_GetPriority)(self as _wxHtmlProcessor ptr) as wxInt

_DS(wxHtmlProcessor_Enable)(self as _wxHtmlProcessor ptr, enable as wxBool)

_DF(wxHtmlProcessor_IsEnabled)(self as _wxHtmlProcessor ptr) as wxBool

_DF(wxHtmlRenderingInfo_ctor)() as _wxHtmlRenderingInfo ptr

_DS(wxHtmlRenderingInfo_dtor)(self as _wxHtmlRenderingInfo ptr)

_DS(wxHtmlRenderingInfo_SetSelection)(self as _wxHtmlRenderingInfo ptr, selection as _wxHtmlSelection ptr)

_DF(wxHtmlRenderingInfo_GetSelection)(self as _wxHtmlRenderingInfo ptr) as _wxHtmlSelection ptr

' class _wxHtmlSelection
_DF(wxHtmlSelection_ctor)() as _wxHtmlSelection ptr

_DS(wxHtmlSelection_dtor)(self as _wxHtmlSelection ptr)

_DS(wxHtmlSelection_Set)(self as _wxHtmlSelection ptr, fromPos as _wxPoint ptr, fromCell as _wxHtmlCell ptr, toPos as _wxPoint ptr, toCell as _wxHtmlCell ptr)

_DS(wxHtmlSelection_Set2)(self as _wxHtmlSelection ptr, fromCell as _wxHtmlCell ptr, toCell as _wxHtmlCell ptr)

_DF(wxHtmlSelection_GetFromCell)(self as _wxHtmlSelection ptr) as _wxHtmlCell ptr

_DF(wxHtmlSelection_GetToCell)(self as _wxHtmlSelection ptr) as _wxHtmlCell ptr

_DS(wxHtmlSelection_GetFromPos)(self as _wxHtmlSelection ptr, fromPos as _wxPoint ptr)

_DS(wxHtmlSelection_GetToPos)(self as _wxHtmlSelection ptr, toPos as _wxPoint ptr)

_DS(wxHtmlSelection_GetFromPrivPos)(self as _wxHtmlSelection ptr, fromPrivPos as _wxPoint ptr)

_DS(wxHtmlSelection_GetToPrivPos)(self as _wxHtmlSelection ptr, toPrivPos as _wxPoint ptr)

_DS(wxHtmlSelection_SetFromPrivPos)(self as _wxHtmlSelection ptr, p as _wxPoint ptr)

_DS(wxHtmlSelection_SetToPrivPos)(self as _wxHtmlSelection ptr, p as _wxPoint ptr)

_DS(wxHtmlSelection_ClearPrivPos)(self as _wxHtmlSelection ptr)

_DF(wxHtmlSelection_IsEmpty)(self as _wxHtmlSelection ptr) as wxBool

' class wxHtmlEasyPrinting
_DF(wxHtmlEasyPrinting_ctor)(nam as _wxString ptr, parent as _wxWindow ptr) as _wxHtmlEasyPrinting ptr 

_DF(wxHtmlEasyPrinting_PreviewFile)(self as _wxHtmlEasyPrinting ptr, htmlfile as _wxString ptr) as wxBool

_DF(wxHtmlEasyPrinting_PreviewText)(self as _wxHtmlEasyPrinting ptr, htmltext as _wxString ptr, basepath as _wxString ptr) as wxBool

_DF(wxHtmlEasyPrinting_PrintFile)(self as _wxHtmlEasyPrinting ptr, htmlfile as _wxString ptr) as wxBool

_DF(wxHtmlEasyPrinting_PrintText)(self as _wxHtmlEasyPrinting ptr, htmltext as _wxString ptr, basepath as _wxString ptr) as wxBool

_DS(wxHtmlEasyPrinting_PageSetup)(self as _wxHtmlEasyPrinting ptr)

_DS(wxHtmlEasyPrinting_SetHeader)(self as _wxHtmlEasyPrinting ptr, header as _wxString ptr, page as wxInt)

_DS(wxHtmlEasyPrinting_SetFooter)(self as _wxHtmlEasyPrinting ptr, footer as _wxString ptr, page as wxInt)

_DS(wxHtmlEasyPrinting_SetFonts)(self as _wxHtmlEasyPrinting ptr, normalFace as _wxString ptr, fixedFace as _wxString ptr, sizes as wxInt ptr)

_DS(wxHtmlEasyPrinting_SetStandardFonts)(self as _wxHtmlEasyPrinting ptr, size as wxInt, normalFace as _wxString ptr, fixedFace as _wxString ptr)

_DF(wxHtmlEasyPrinting_GetPrintData)(self as _wxHtmlEasyPrinting ptr) as _wxPrintData ptr

_DF(wxHtmlEasyPrinting_GetPageSetupData)(self as _wxHtmlEasyPrinting ptr) as _wxPageSetupDialogData ptr


#endif ' __html_bi__
