#ifndef __log_bi__
#define __log_bi__

#include once "common.bi"

' different standard log levels (you may also define your own)
enum wxLogLevel
  wxLOG_FatalError ' program can't continue, abort immediately
  wxLOG_Error      ' a serious error, user must be informed about it
  wxLOG_Warning    ' user is normally informed about it but may be ignored
  wxLOG_Message    ' normal message (i.e. normal output of a non GUI app)
  wxLOG_Status     ' informational: might go to the status line of GUI app
  wxLOG_Info       ' informational message (a.k.a. 'Verbose')
  wxLOG_Debug      ' never shown to the user, disabled in release mode
  wxLOG_Trace      ' trace messages are also only enabled in debug mode
  wxLOG_Progress   ' used for progress indicator (not yet)
  wxLOG_User = 100 ' user defined levels start here
  wxLOG_Max = 10000
end enum
' trace mask bits
#define wxTraceMemAlloc &H0001  ' trace memory allocation (new/delete)
#define wxTraceMessages &H0002  ' trace window messages/X callbacks
#define wxTraceResAlloc &H0004  ' trace GDI resource allocation
#define wxTraceRefCount &H0008 

type wxTraceMask as wxUint


_DF(wxLog_ctor) as _wxLog ptr

_DS(wxLog_dtor)(self as _wxLog ptr)

_DS(wxLog_Flush)(self as _wxLog ptr)

_DF(wxLog_HasPendingMessages)(self as _wxLog ptr) as wxBool

_DF(wxLog_GetActiveTarget) as _wxLog ptr

_DF(wxLog_SetActiveTargetTextCtrl)(pLogger as _wxTextCtrl ptr) as _wxLog ptr

_DF(wxLog_IsEnabled) as wxBool

_DF(wxLog_EnableLogging)(doit as wxBool) as wxBool

_DS(wxLog_FlushActive)

_DS(wxLog_Suspend)

_DS(wxLog_Resume)

_DS(wxLog_SetVerbose)(bVerbose as wxBool)

_DS(wxLog_SetLogLevel)(logLevel as wxLogLevel)

_DS(wxLog_DontCreateOnDemand)

_DS(wxLog_LogTraceStringMask)(mask as _wxString ptr, msg as _wxString ptr)

_DS(wxLog_SetTraceMask)(ulMask as wxTraceMask)

_DS(wxLog_AddTraceMask)(tMask as _wxString ptr)

_DS(wxLog_RemoveTraceMask)(tMask as _wxString ptr)

_DS(wxLog_ClearTraceMasks)

_DF(wxLog_GetTraceMasks) as _wxArrayString ptr

_DS(wxLog_SetTimestamp)(ts as _wxString ptr)

_DF(wxLog_GetVerbose) as wxBool

_DF(xLog_GetTraceMask) as wxTraceMask

_DF(wxLog_IsAllowedTraceMask)(mask as _wxString ptr) as wxBool

_DF(wxLog_GetLogLevel) as wxLogLevel

_DF(wxLog_GetTimestamp) as _wxString ptr

_DS(wxLog_Log_Function)(iWhat as wxInt, szFormat as _wxString ptr)

#endif ' __log_bi__



