#ifndef __printer_bi__
#define __printer_bi__

#include once "common.bi"

' Virtual method delegate pointer types
type Virtual_NoParams        as sub      APICALL 
type Virtual_ParamsInt       as function APICALL (as wxInt) as wxBool
type Virtual_OnBeginDocument as function APICALL (startPage as wxInt, endPage as wxInt) as wxBool
type Virtual_GetPageInfo     as sub      APICALL (minPage as wxInt ptr, maxPage as wxInt ptr, pageFrom as wxInt ptr, pageTo as wxInt ptr)

' class wxPrinter
_DF(wxPrinter_ctor)(dialogdata as _wxPrintDialogData ptr) as _wxPrinter ptr

_DF(wxPrinter_CreateAbortWindow)(self as _wxPrinter ptr, parent as _wxWindow ptr, printout as _wxPrintout ptr) as _wxWindow ptr

_DS(wxPrinter_ReportError)(self as _wxPrinter ptr, parent as _wxWindow ptr, printout as _wxPrintout ptr, message as _wxString ptr)

_DF(wxPrinter_GetPrintDialogData)(self as _wxPrinter ptr) as _wxPrintDialogData ptr

_DF(wxPrinter_GetAbort)(self as _wxPrinter ptr) as wxBool

_DF(wxPrinter_GetLastError)(self as _wxPrinter ptr) as wxPrinterError

_DF(wxPrinter_Setup)(self as _wxPrinter ptr, parent as _wxWindow ptr) as wxBool

_DF(wxPrinter_Print)(self as _wxPrinter ptr, parent as _wxWindow ptr, printout as _wxPrintout ptr, prompt as wxBool) as wxBool

_DF(wxPrinter_PrintDialog)(self as _wxPrinter ptr, parent as _wxWindow ptr) as _wxDC ptr

' class wxPrintout
_DF(wxPrintout_ctor)(titleArg as _wxString ptr) as _wxPrintout ptr

_DS(wxPrintout_RegisterVirtual)(self as _wxPrintout ptr, _
                                onBeginDocument   as Virtual_OnBeginDocument, _
                                onEndDocument     as Virtual_NoParams , _
                                onBeginPrinting   as Virtual_NoParams , _
                                onEndPrinting     as Virtual_NoParams ,_
                                onPreparePrinting as Virtual_NoParams, _
                                hasPage           as Virtual_ParamsInt,_
                                onPrintPage       as Virtual_ParamsInt, _
                                getPageInfo       as Virtual_GetPageInfo)

_DF(wxPrintout_OnBeginDocument)(self as _wxPrintout ptr, startPage as wxInt, endPage as wxInt) as wxBool

_DS(wxPrintout_OnEndDocument)(self as _wxPrintout ptr)

_DS(wxPrintout_OnBeginPrinting)(self as _wxPrintout ptr)

_DS(wxPrintout_OnEndPrinting)(self as _wxPrintout ptr)

_DS(wxPrintout_OnPreparePrinting)(self as _wxPrintout ptr)

_DF(wxPrintout_HasPage)(self as _wxPrintout ptr, page as wxInt) as wxBool

_DS(wxPrintout_GetPageInfo)(self as _wxPrintout ptr, minPage as wxInt ptr, maxPage as wxInt ptr, pageFrom as wxInt ptr, pageTo as wxInt ptr)

_DF(wxPrintout_GetTitle)(self as _wxPrintout ptr) as _wxString ptr

_DF(wxPrintout_GetDC)(self as _wxPrintout ptr) as _wxDC ptr

_DS(wxPrintout_SetDC)(self as _wxPrintout ptr, dc as _wxDC ptr)

_DS(wxPrintout_SetPageSizePixels)(self as _wxPrintout ptr, w as wxInt, h as wxInt)

_DS(wxPrintout_GetPageSizePixels)(self as _wxPrintout ptr, w as wxInt ptr, h as wxInt ptr)

_DS(wxPrintout_SetPageSizeMM)(self as _wxPrintout ptr, w as wxInt, h as wxInt)

_DS(wxPrintout_GetPageSizeMM)(self as _wxPrintout ptr, w as wxInt ptr, h as wxInt ptr)

_DS(wxPrintout_SetPPIScreen)(self as _wxPrintout ptr, x as wxInt, y as wxInt)

_DS(wxPrintout_GetPPIScreen)(self as _wxPrintout ptr, x as wxInt ptr, y as wxInt ptr)

_DS(wxPrintout_SetPPIPrinter)(self as _wxPrintout ptr, x as wxInt, y as wxInt)

_DS(wxPrintout_GetPPIPrinter)(self as _wxPrintout ptr, x as wxInt ptr, y as wxInt ptr)

_DF(wxPrintout_IsPreview)(self as _wxPrintout ptr) as wxBool

_DS(wxPrintout_SetIsPreview)(self as _wxPrintout ptr, flag as wxBool)


#endif ' __printer_bi__