#ifndef __string_object_bi__
#define __string_object_bi__

#include once "string.bi"

type wxString
  declare destructor
  declare constructor(other as _wxString ptr=WX_NULL)
  declare constructor(p as zstring ptr)
  declare constructor(p as wchar_t ptr)
  
  declare operator cast as _wxString ptr
  declare operator cast as String
  declare function Length as size_t
  declare function CharAtUTF16(index as size_t) as wchar_t
  declare function Conversion as _wxWCharBuffer ptr
  declare function ConversionUTF8 as _wxWCharBuffer ptr

  
  private:
  as  wxBool       HasOwner
  as _wxString ptr self
end type

destructor wxString
  if (HasOwner=WX_TRUE) then return 
  dprint("wxString~")
  wxString_dtor self
end destructor

constructor wxString(other as _wxString ptr)
  self=other
  HasOwner=WX_TRUE
end constructor

constructor wxString(p as zstring ptr)
  dprint("wxStringUTF8(" & *p & ")")
  self=wxString_ctorUTF8(p)
end constructor

constructor wxString(p as wchar_t ptr)
  dprint("wxStringUTF16(" & *p & ")")
  self=wxString_ctorUTF16(p)
end constructor
operator wxString.cast as _wxString ptr
  dprint("wxString->_wxString")
  return self
end operator
operator wxString.cast as String
  dprint("wxString->String")
  dim as string ret
  dim as size_t nChars = Length
  if nChars>0 then
    ret = space(nChars)
    for i as integer=0 to nChars-1
      ret[i]=CharAtUTF16(i)
    next
  end if
  return ret
end operator

function wxString.Length as size_t
  return wxString_GetLength(self)
end function
function wxString.CharAtUTF16(index as size_t) as wchar_t
  return wxString_CharAtUTF16(self,index)
end function
function wxString.Conversion as _wxWCharBuffer ptr
  return wxString_Conversion(self)
end function
function wxString.ConversionUTF8 as _wxWCharBuffer ptr
  return wxString_ConversionUTF8(self)
end function

#endif ' __string_object_bi__
