#ifndef __xmlresource_bi__
#define __xmlresource_bi__

#include once "common.bi"

enum XmlResourceFlags
  XRC_USE_LOCALE     = 1
  XRC_NO_SUBCLASSING = 2
end enum
  
type XmlSubclassCreate as function APICALL (nam as _wxString ptr) as _wxObject ptr 

' class wxXmlSubclassFactory
_DS(wxXmlSubclassFactory_ctor)(create as XmlSubclassCreate)

' class wxXmlResource
_DF(wxXmlResource_ctor)(flags as XmlResourceFlags) as _wxXmlResource ptr

_DF(wxXmlResource_ctorByFilemask)(filemask as _wxString ptr, flags as XmlResourceFlags = XRC_USE_LOCALE) as _wxXmlResource ptr

_DS(wxXmlResource_InitAllHandlers)(self as _wxXmlResource ptr)

_DF(wxXmlResource_Load)(self as _wxXmlResource ptr, filemask as _wxString ptr) as wxChar

_DF(wxXmlResource_LoadFromByteArray)(self as _wxXmlResource ptr, filemask as _wxString ptr, pData as wxChar ptr, length as size_t) as wxChar

_DF(wxXmlResource_LoadDialog)(self as _wxXmlResource ptr, parent as _wxWindow ptr, nam as _wxString ptr) as _wxDialog ptr

_DF(wxXmlResource_LoadDialogDlg)(self as _wxXmlResource ptr, dlg as _wxDialog ptr, parent as _wxWindow ptr, nam as _wxString ptr) as wxChar

_DF(wxXmlResource_GetXRCID)(cstrid as _wxString ptr) as wxInt

_DF(wxXmlResource_GetVersion)(self as _wxXmlResource ptr) as wxInt

_DF(wxXmlResource_LoadFrameWithFrame)(self as _wxXmlResource ptr, frame as _wxFrame ptr, parent as _wxWindow ptr, nam as _wxString ptr) as wxChar

_DF(wxXmlResource_LoadFrame)(self as _wxXmlResource ptr, parent as _wxWindow ptr, nam as _wxString ptr) as _wxFrame ptr

_DF(wxXmlResource_LoadBitmap)(self as _wxXmlResource ptr, nam as _wxString ptr) as _wxBitmap ptr

_DF(wxXmlResource_LoadIcon)(self as _wxXmlResource ptr, nam as _wxString ptr) as _wxIcon ptr

_DF(wxXmlResource_LoadMenu)(self as _wxXmlResource ptr, nam as _wxString ptr) as _wxMenu ptr

_DF(wxXmlResource_LoadMenuBarWithParent)(self as _wxXmlResource ptr, parent as _wxWindow ptr, nam as _wxString ptr) as _wxMenuBar ptr

_DF(wxXmlResource_LoadMenuBar)(self as _wxXmlResource ptr, nam as _wxString ptr) as _wxMenuBar ptr

_DF(wxXmlResource_LoadPanelWithPanel)(self as _wxXmlResource ptr,panel as _wxPanel ptr, parent as _wxWindow ptr, nam as _wxString ptr) as wxChar

_DF(wxXmlResource_LoadPanel)(self as _wxXmlResource ptr, parent as _wxWindow ptr, nam as _wxString ptr) as _wxPanel ptr

_DF(wxXmlResource_LoadToolBar)(self as _wxXmlResource ptr, parent as _wxWindow ptr, nam as _wxString ptr) as _wxToolBar ptr

_DS(wxXmlResource_SetFlags)(self as _wxXmlResource ptr, flags as wxInt)

_DF(wxXmlResource_GetFlags)(self as _wxXmlResource ptr) as wxInt

_DF(wxXmlResource_CompareVersion)(self as _wxXmlResource ptr, major as wxInt, minor as wxInt, release as wxInt, revision as wxInt) as wxInt

'_DS(wxXmlResource_UpdateResources)(self as _wxXmlResource ptr)

_DF(wxXmlResource_AttachUnknownControl)(self as _wxXmlResource ptr, nam as _wxString ptr, control as _wxWindow ptr, parent as _wxWindow ptr) as wxChar

#endif ' __xmlresource_bi__
